# Troubleshoot missing editor

<p class="description">How to troubleshoot a missing editor error on Toolpad.</p>

## When using Visual Studio Code

1. When clicking on the "Open editor" button on the query editor, you might run into the following error

{{"component": "modules/components/DocsImage.tsx", "src": "/static/toolpad/docs/how-to-guides/editor-path/missing-editor.png", "alt": "Missing editor error", "caption": "Missing editor error"}}

2. This is most likely caused by a missing `code` command in your system `PATH`.

3. To fix this, go to the Command Palette, through `View` &rarr; `Command Palette` (or <kbd>Cmd</kbd> /<kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>P</kbd>)

{{"component": "modules/components/DocsImage.tsx", "src": "/static/toolpad/docs/how-to-guides/editor-path/command-palette.png", "alt": "VS Code command palette", "caption": "The command palette on Visual Studio Code", "aspectRatio": 2, "width": 600, "zoom": false }}

4. Type `code` to find the `Install 'code' command in PATH` option, and press enter to select it:

{{"component": "modules/components/DocsImage.tsx", "src": "/static/toolpad/docs/how-to-guides/editor-path/code-install.png", "alt": "VS Code add 'code' to PATH", "caption": "Install 'code' option", "aspectRatio": 2, "width": 600, "zoom": false }}
