<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# Autocomplete

<p class="description">API docs for the Toolpad Autocomplete component.</p>

## Properties

| Name                                      | Type                                   | Default                                     | Description                                                                                                                                                                                                                                                                          |
| :---------------------------------------- | :------------------------------------- | :------------------------------------------ | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">options</span>    | <span class="prop-type">array</span>   | <span class="prop-default">[]</span>        | The options available to search from.                                                                                                                                                                                                                                                |
| <span class="prop-name">value</span>      | <span class="prop-type">string</span>  | <span class="prop-default">""</span>        | The value of the autocomplete.                                                                                                                                                                                                                                                       |
| <span class="prop-name">label</span>      | <span class="prop-type">string</span>  | <span class="prop-default">"Search…"</span> | The label to display for the autocomplete.                                                                                                                                                                                                                                           |
| <span class="prop-name">fullWidth</span>  | <span class="prop-type">boolean</span> | <span class="prop-default">true</span>      | If true, the autocomplete will take up the full width of its container.                                                                                                                                                                                                              |
| <span class="prop-name">size</span>       | <span class="prop-type">string</span>  | <span class="prop-default">"small"</span>   | The size of the autocomplete. One of `small`, `medium`, or `large`.                                                                                                                                                                                                                  |
| <span class="prop-name">loading</span>    | <span class="prop-type">boolean</span> |                                             | If true, the autocomplete will display a loading indicator.                                                                                                                                                                                                                          |
| <span class="prop-name">disabled</span>   | <span class="prop-type">boolean</span> |                                             | If true, the autocomplete will be disabled.                                                                                                                                                                                                                                          |
| <span class="prop-name">name</span>       | <span class="prop-type">string</span>  |                                             | Name of this input. Used as a reference in form data.                                                                                                                                                                                                                                |
| <span class="prop-name">isRequired</span> | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>     | Whether the input is required to have a value.                                                                                                                                                                                                                                       |
| <span class="prop-name">isInvalid</span>  | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>     | Whether the input value is invalid.                                                                                                                                                                                                                                                  |
| <span class="prop-name">minLength</span>  | <span class="prop-type">number</span>  | <span class="prop-default">0</span>         | Minimum value length.                                                                                                                                                                                                                                                                |
| <span class="prop-name">maxLength</span>  | <span class="prop-type">number</span>  | <span class="prop-default">0</span>         | Maximum value length.                                                                                                                                                                                                                                                                |
| <span class="prop-name">sx</span>         | <span class="prop-type">object</span>  |                                             | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
