<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# Button

<p class="description">API docs for the Toolpad Button component.</p>

The Material UI [Button](https://mui.com/material-ui/react-button/) component.

Buttons allow users to take actions, and make choices, with a single tap.

## Properties

| Name                                     | Type                                   | Default                                         | Description                                                                                                                                                                                                                                                                          |
| :--------------------------------------- | :------------------------------------- | :---------------------------------------------- | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">onClick</span>   | <span class="prop-type">event</span>   |                                                 | Add logic to be executed when the user clicks the button.                                                                                                                                                                                                                            |
| <span class="prop-name">content</span>   | <span class="prop-type">string</span>  | <span class="prop-default">"Button Text"</span> | Will appear as the text content of the button.                                                                                                                                                                                                                                       |
| <span class="prop-name">variant</span>   | <span class="prop-type">string</span>  | <span class="prop-default">"contained"</span>   | One of the available Material UI Button [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `contained`, `outlined` or `text`                                                                                                                    |
| <span class="prop-name">size</span>      | <span class="prop-type">string</span>  | <span class="prop-default">"small"</span>       | The size of the component. One of `small`, `medium`, or `large`.                                                                                                                                                                                                                     |
| <span class="prop-name">color</span>     | <span class="prop-type">string</span>  | <span class="prop-default">"primary"</span>     | The theme color of the component.                                                                                                                                                                                                                                                    |
| <span class="prop-name">fullWidth</span> | <span class="prop-type">boolean</span> |                                                 | Whether the button should occupy all available horizontal space.                                                                                                                                                                                                                     |
| <span class="prop-name">loading</span>   | <span class="prop-type">boolean</span> |                                                 | Displays a loading animation indicating the button isn't interactive yet                                                                                                                                                                                                             |
| <span class="prop-name">disabled</span>  | <span class="prop-type">boolean</span> |                                                 | Whether the button is disabled.                                                                                                                                                                                                                                                      |
| <span class="prop-name">sx</span>        | <span class="prop-type">object</span>  |                                                 | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
