<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# DataGrid

<p class="description">API docs for the Toolpad DataGrid component.</p>

The MUI X [Data Grid](https://mui.com/x/react-data-grid/) component.

The datagrid lets users display tabular data in a flexible grid.

## Properties

| Name                                       | Type                                   | Default                                     | Description                                                                                                                                                                                                                                                                          |
| :----------------------------------------- | :------------------------------------- | :------------------------------------------ | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">rows</span>        | <span class="prop-type">array</span>   |                                             | The data to be displayed as rows. Must be an array of objects.                                                                                                                                                                                                                       |
| <span class="prop-name">columns</span>     | <span class="prop-type">array</span>   |                                             | The columns to be displayed.                                                                                                                                                                                                                                                         |
| <span class="prop-name">rowIdField</span>  | <span class="prop-type">string</span>  |                                             | Defines which column contains the [id](https://mui.com/x/react-data-grid/row-definition/#row-identifier) that uniquely identifies each row.                                                                                                                                          |
| <span class="prop-name">selection</span>   | <span class="prop-type">object</span>  | <span class="prop-default">null</span>      | The currently selected row. Or `null` in case no row has been selected.                                                                                                                                                                                                              |
| <span class="prop-name">density</span>     | <span class="prop-type">string</span>  | <span class="prop-default">"compact"</span> | The [density](https://mui.com/x/react-data-grid/accessibility/#density-prop) of the rows. Possible values are `compact`, `standard`, or `comfortable`.                                                                                                                               |
| <span class="prop-name">height</span>      | <span class="prop-type">number</span>  | <span class="prop-default">350</span>       |                                                                                                                                                                                                                                                                                      |
| <span class="prop-name">loading</span>     | <span class="prop-type">boolean</span> |                                             | Displays a loading animation indicating the datagrid isn't ready to present data yet.                                                                                                                                                                                                |
| <span class="prop-name">hideToolbar</span> | <span class="prop-type">boolean</span> |                                             | Hide the toolbar area that contains the data grid user controls.                                                                                                                                                                                                                     |
| <span class="prop-name">sx</span>          | <span class="prop-type">object</span>  |                                             | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
