<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# DatePicker

<p class="description">API docs for the Toolpad DatePicker component.</p>

The MUI X [Date Picker](https://mui.com/x/react-date-pickers/date-picker/) component.

The date picker lets the user select a date.

## Properties

| Name                                        | Type                                   | Default                                      | Description                                                                                                                                                                                                                                                                          |
| :------------------------------------------ | :------------------------------------- | :------------------------------------------- | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">value</span>        | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | The currently selected date.                                                                                                                                                                                                                                                         |
| <span class="prop-name">format</span>       | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | The [format](https://day.js.org/docs/en/display/format) of the date in the UI. The value for the bindings will always be in the `YYYY-MM-DD` format. Leave empty to let the end-user locale define the format.                                                                       |
| <span class="prop-name">defaultValue</span> | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | A default value for the date picker.                                                                                                                                                                                                                                                 |
| <span class="prop-name">label</span>        | <span class="prop-type">string</span>  |                                              | A label that describes the content of the date picker. e.g. "Arrival date".                                                                                                                                                                                                          |
| <span class="prop-name">name</span>         | <span class="prop-type">string</span>  |                                              | Name of this input. Used as a reference in form data.                                                                                                                                                                                                                                |
| <span class="prop-name">variant</span>      | <span class="prop-type">string</span>  | <span class="prop-default">"outlined"</span> | One of the available MUI TextField [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `outlined`, `filled` or `standard`                                                                                                                        |
| <span class="prop-name">size</span>         | <span class="prop-type">string</span>  | <span class="prop-default">"small"</span>    | The size of the component. One of `small`, or `medium`.                                                                                                                                                                                                                              |
| <span class="prop-name">fullWidth</span>    | <span class="prop-type">boolean</span> |                                              | Whether the button should occupy all available horizontal space.                                                                                                                                                                                                                     |
| <span class="prop-name">disabled</span>     | <span class="prop-type">boolean</span> |                                              | The date picker is disabled.                                                                                                                                                                                                                                                         |
| <span class="prop-name">isRequired</span>   | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>      | Whether the input is required to have a value.                                                                                                                                                                                                                                       |
| <span class="prop-name">isInvalid</span>    | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>      | Whether the input value is invalid.                                                                                                                                                                                                                                                  |
| <span class="prop-name">sx</span>           | <span class="prop-type">object</span>  |                                              | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
