<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# Image

<p class="description">API docs for the Toolpad Image component.</p>

The Image component lets you display images.

## Properties

| Name                                   | Type                                   | Default                                     | Description                                                                                                                                                                                                                                                                                           |
| :------------------------------------- | :------------------------------------- | :------------------------------------------ | :---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">src</span>     | <span class="prop-type">string</span>  |                                             | The url of the image. Must resolve to an image file.                                                                                                                                                                                                                                                  |
| <span class="prop-name">alt</span>     | <span class="prop-type">string</span>  | <span class="prop-default">""</span>        | The `alt` attribute holds a text description of the image. screen readers read this description out to their users so they know what the image means. Alt text is also displayed on the page if the image can't be loaded for some reason: for example, network errors, content blocking, or linkrot. |
| <span class="prop-name">fit</span>     | <span class="prop-type">string</span>  | <span class="prop-default">"contain"</span> | Defines how the image should [resize](https://developer.mozilla.org/en-US/docs/Web/CSS/object-fit) to its container.                                                                                                                                                                                  |
| <span class="prop-name">width</span>   | <span class="prop-type">number</span>  | <span class="prop-default">400</span>       | The image width in pixels                                                                                                                                                                                                                                                                             |
| <span class="prop-name">height</span>  | <span class="prop-type">number</span>  | <span class="prop-default">300</span>       |                                                                                                                                                                                                                                                                                                       |
| <span class="prop-name">loading</span> | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>     | Displays a loading animation indicating the image is still loading                                                                                                                                                                                                                                    |
| <span class="prop-name">sx</span>      | <span class="prop-type">object</span>  |                                             | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.                  |
