<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# Select

<p class="description">API docs for the Toolpad Select component.</p>

The Select component lets you select a value from a set of options.

## Properties

| Name                                        | Type                                   | Default                                      | Description                                                                                                                                                                                                                                                                          |
| :------------------------------------------ | :------------------------------------- | :------------------------------------------- | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">options</span>      | <span class="prop-type">array</span>   | <span class="prop-default">[]</span>         | The available options to select from.                                                                                                                                                                                                                                                |
| <span class="prop-name">value</span>        | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | The currently selected value.                                                                                                                                                                                                                                                        |
| <span class="prop-name">defaultValue</span> | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | A default value.                                                                                                                                                                                                                                                                     |
| <span class="prop-name">label</span>        | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | A label that describes the option that can be selected. e.g. "Country".                                                                                                                                                                                                              |
| <span class="prop-name">variant</span>      | <span class="prop-type">string</span>  | <span class="prop-default">"outlined"</span> | One of the available MUI TextField [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `outlined`, `filled` or `standard`                                                                                                                        |
| <span class="prop-name">size</span>         | <span class="prop-type">string</span>  | <span class="prop-default">"small"</span>    | The size of the select. One of `small`, or `medium`.                                                                                                                                                                                                                                 |
| <span class="prop-name">fullWidth</span>    | <span class="prop-type">boolean</span> |                                              | Whether the select should occupy all available horizontal space.                                                                                                                                                                                                                     |
| <span class="prop-name">disabled</span>     | <span class="prop-type">boolean</span> |                                              | Whether the select is disabled.                                                                                                                                                                                                                                                      |
| <span class="prop-name">name</span>         | <span class="prop-type">string</span>  |                                              | Name of this input. Used as a reference in form data.                                                                                                                                                                                                                                |
| <span class="prop-name">isRequired</span>   | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>      | Whether the input is required to have a value.                                                                                                                                                                                                                                       |
| <span class="prop-name">isInvalid</span>    | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>      | Whether the input value is invalid.                                                                                                                                                                                                                                                  |
| <span class="prop-name">sx</span>           | <span class="prop-type">object</span>  |                                              | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
