<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# TextField

<p class="description">API docs for the Toolpad TextField component.</p>

The TextField component lets you input a text value.

## Properties

| Name                                        | Type                                   | Default                                      | Description                                                                                                                                                                                                                                                                          |
| :------------------------------------------ | :------------------------------------- | :------------------------------------------- | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">value</span>        | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | The value that is controlled by this text input.                                                                                                                                                                                                                                     |
| <span class="prop-name">defaultValue</span> | <span class="prop-type">string</span>  | <span class="prop-default">""</span>         | A default value for when the input is still empty.                                                                                                                                                                                                                                   |
| <span class="prop-name">label</span>        | <span class="prop-type">string</span>  |                                              | A label that describes the content of the text field. e.g. "First name".                                                                                                                                                                                                             |
| <span class="prop-name">variant</span>      | <span class="prop-type">string</span>  | <span class="prop-default">"outlined"</span> | One of the available MUI TextField [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `outlined`, `filled` or `standard`                                                                                                                        |
| <span class="prop-name">size</span>         | <span class="prop-type">string</span>  | <span class="prop-default">"small"</span>    | The size of the input. One of `small`, or `medium`.                                                                                                                                                                                                                                  |
| <span class="prop-name">fullWidth</span>    | <span class="prop-type">boolean</span> |                                              | Whether the input should occupy all available horizontal space.                                                                                                                                                                                                                      |
| <span class="prop-name">disabled</span>     | <span class="prop-type">boolean</span> |                                              | Whether the input is disabled.                                                                                                                                                                                                                                                       |
| <span class="prop-name">name</span>         | <span class="prop-type">string</span>  |                                              | Name of this input. Used as a reference in form data.                                                                                                                                                                                                                                |
| <span class="prop-name">isRequired</span>   | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>      | Whether the input is required to have a value.                                                                                                                                                                                                                                       |
| <span class="prop-name">isInvalid</span>    | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>      | Whether the input value is invalid.                                                                                                                                                                                                                                                  |
| <span class="prop-name">minLength</span>    | <span class="prop-type">number</span>  | <span class="prop-default">0</span>          | Minimum value length.                                                                                                                                                                                                                                                                |
| <span class="prop-name">maxLength</span>    | <span class="prop-type">number</span>  | <span class="prop-default">0</span>          | Maximum value length.                                                                                                                                                                                                                                                                |
| <span class="prop-name">sx</span>           | <span class="prop-type">object</span>  |                                              | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
