<!-- This file has been auto-generated using `yarn docs:build:api`. -->

# Text

<p class="description">API docs for the Toolpad Text component.</p>

The Text component lets you display text. Text can be rendered in multiple forms: plain, as a link, or as markdown.

## Properties

| Name                                   | Type                                   | Default                                         | Description                                                                                                                                                                                                                                                                          |
| :------------------------------------- | :------------------------------------- | :---------------------------------------------- | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <span class="prop-name">mode</span>    | <span class="prop-type">string</span>  | <span class="prop-default">"text"</span>        | Defines how the content is rendered. Either as plain text, markdown, or as a link.                                                                                                                                                                                                   |
| <span class="prop-name">value</span>   | <span class="prop-type">string</span>  | <span class="prop-default">"text"</span>        | The text content.                                                                                                                                                                                                                                                                    |
| <span class="prop-name">href</span>    | <span class="prop-type">string</span>  | <span class="prop-default">"about:blank"</span> | The url that is being linked.                                                                                                                                                                                                                                                        |
| <span class="prop-name">variant</span> | <span class="prop-type">string</span>  | <span class="prop-default">"body1"</span>       | The MUI typography [variant](https://mui.com/material-ui/customization/typography/#variants) that is used to display the text.                                                                                                                                                       |
| <span class="prop-name">loading</span> | <span class="prop-type">boolean</span> | <span class="prop-default">false</span>         | Displays a loading animation instead of the text. Can be used when the content is not available yet.                                                                                                                                                                                 |
| <span class="prop-name">sx</span>      | <span class="prop-type">object</span>  |                                                 | The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need. |
