"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Chart.tsx
var Chart_exports = {};
__export(Chart_exports, {
  CHART_DATA_SERIES_KINDS: () => CHART_DATA_SERIES_KINDS,
  default: () => Chart_default
});
module.exports = __toCommonJS(Chart_exports);
var React2 = __toESM(require("react"), 1);
var import_toolpad_core = require("@mui/toolpad-core");
var import_material2 = require("@mui/material");
var import_recharts = require("recharts");
var import_errors2 = require("@mui/toolpad-utils/errors");

// src/components/ErrorOverlay.tsx
var import_material = require("@mui/material");
var React = __toESM(require("react"), 1);
var import_errors = require("@mui/toolpad-utils/errors");
var import_Error = __toESM(require("@mui/icons-material/Error"), 1);
var OverlayRoot = (0, import_material.styled)("div")(({ theme }) => ({
  position: "absolute",
  inset: "0 0 0 0",
  display: "flex",
  flexDirection: "column",
  alignItems: "center",
  justifyContent: "center",
  borderWidth: 1,
  borderStyle: "solid",
  borderRadius: theme.shape.borderRadius,
  borderColor: theme.palette.divider
}));
function ErrorOverlay({ error }) {
  const errMessage = error ? (0, import_errors.errorFrom)(error).message : null;
  return errMessage ? /* @__PURE__ */ React.createElement(OverlayRoot, null, /* @__PURE__ */ React.createElement(import_material.Typography, { sx: { display: "flex", flexDirection: "row", gap: 1 } }, /* @__PURE__ */ React.createElement(import_Error.default, { fontSize: "small", color: "error" }), "Error"), /* @__PURE__ */ React.createElement(import_material.Typography, { variant: "body2" }, errMessage)) : null;
}

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/Chart.tsx
var CHART_DATA_SERIES_KINDS = ["line", "bar", "area", "scatter"];
function getBarChartDataSeriesNormalizedYKey(dataSeries, index) {
  return `${dataSeries.label}-${dataSeries.yKey}-${index}`;
}
function Chart({ data = [], loading, error, height, sx }) {
  const xValues = React2.useMemo(
    () => data.flatMap((dataSeries) => {
      if (!dataSeries.xKey || !dataSeries.data) {
        return [];
      }
      return dataSeries.data.map((dataSeriesPoint) => dataSeriesPoint[dataSeries.xKey]);
    }).filter((value, index, array) => array.indexOf(value) === index).sort(
      (a, b) => typeof a === "number" && typeof b === "number" ? a - b : 0
    ),
    [data]
  );
  const barChartData = React2.useMemo(() => {
    return xValues.map((xValue) => {
      const yValues = data.reduce((acc, dataSeries, index) => {
        if (dataSeries.kind !== "bar" || !dataSeries.xKey || !dataSeries.yKey) {
          return acc;
        }
        const point = (dataSeries.data || []).find(
          (dataSeriesPoint) => dataSeriesPoint[dataSeries.xKey] === xValue
        );
        return {
          ...acc,
          [getBarChartDataSeriesNormalizedYKey(dataSeries, index)]: point ? point[dataSeries.yKey] : 0
        };
      }, {});
      return {
        x: xValue,
        ...yValues
      };
    });
  }, [data, xValues]);
  const hasNonNumberXValues = xValues.some((xValue) => typeof xValue !== "number");
  const displayError = error ? (0, import_errors2.errorFrom)(error) : null;
  const isDataVisible = !loading && !displayError;
  return /* @__PURE__ */ React2.createElement(import_material2.Container, { disableGutters: true, sx: { ...sx, position: "relative" }, "aria-busy": loading }, /* @__PURE__ */ React2.createElement(import_recharts.ResponsiveContainer, { width: "100%", height }, /* @__PURE__ */ React2.createElement(import_recharts.ComposedChart, { data: barChartData, margin: { top: 20, right: 80 } }, isDataVisible ? /* @__PURE__ */ React2.createElement(React2.Fragment, null, /* @__PURE__ */ React2.createElement(import_recharts.CartesianGrid, { strokeDasharray: "3 3" }), /* @__PURE__ */ React2.createElement(
    import_recharts.XAxis,
    {
      dataKey: "x",
      type: hasNonNumberXValues ? "category" : "number",
      allowDuplicatedCategory: false,
      domain: hasNonNumberXValues ? void 0 : [Math.min(...xValues), Math.max(...xValues)]
    }
  ), /* @__PURE__ */ React2.createElement(import_recharts.YAxis, { width: 80 }), /* @__PURE__ */ React2.createElement(import_recharts.Tooltip, null), /* @__PURE__ */ React2.createElement(import_recharts.Legend, null), data.map((dataSeries, index) => {
    if (!dataSeries.data || dataSeries.data.length === 0 || !dataSeries.xKey || !dataSeries.yKey) {
      return null;
    }
    const key = `${dataSeries.label}-${index}`;
    const normalizedData = dataSeries.data.map((dataSeriesPoint) => ({
      x: dataSeriesPoint[dataSeries.xKey],
      [dataSeries.yKey]: dataSeriesPoint[dataSeries.yKey]
    })).sort(
      (a, b) => typeof a[dataSeries.xKey] === "number" && typeof b[dataSeries.xKey] === "number" ? a[dataSeries.xKey] - b[dataSeries.xKey] : 0
    );
    switch (dataSeries.kind) {
      case "bar":
        return /* @__PURE__ */ React2.createElement(
          import_recharts.Bar,
          {
            key,
            dataKey: getBarChartDataSeriesNormalizedYKey(dataSeries, index),
            name: dataSeries.label,
            barSize: 20,
            fill: dataSeries.color
          }
        );
      case "area":
        return /* @__PURE__ */ React2.createElement(
          import_recharts.Area,
          {
            key,
            type: "monotone",
            data: normalizedData,
            dataKey: dataSeries.yKey,
            name: dataSeries.label,
            stroke: dataSeries.color,
            fill: dataSeries.color
          }
        );
      case "scatter":
        return /* @__PURE__ */ React2.createElement(
          import_recharts.Scatter,
          {
            key,
            data: normalizedData,
            dataKey: dataSeries.yKey,
            name: dataSeries.label,
            fill: dataSeries.color
          }
        );
      default:
        return /* @__PURE__ */ React2.createElement(
          import_recharts.Line,
          {
            key,
            type: "monotone",
            data: normalizedData,
            dataKey: dataSeries.yKey,
            name: dataSeries.label,
            stroke: dataSeries.color
          }
        );
    }
  })) : null)), /* @__PURE__ */ React2.createElement(ErrorOverlay, { error: displayError }), loading && !error ? /* @__PURE__ */ React2.createElement(
    import_material2.Skeleton,
    {
      sx: { position: "absolute", inset: "0 0 0 0" },
      variant: "rectangular",
      width: "100%",
      height
    }
  ) : null);
}
var Chart_default = (0, import_toolpad_core.createComponent)(Chart, {
  loadingProp: "loading",
  loadingPropSource: ["data"],
  errorProp: "error",
  resizableHeightProp: "height",
  argTypes: {
    data: {
      helperText: "The data to be displayed.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: "object",
          properties: {
            kind: {
              type: "string",
              enum: CHART_DATA_SERIES_KINDS,
              default: "line"
            },
            label: {
              type: "string"
            },
            data: {
              type: "object",
              default: []
            },
            xKey: {
              type: "string"
            },
            yKey: {
              type: "string"
            },
            color: {
              type: "string"
            }
          }
        }
      },
      control: { type: "ChartData", bindable: false }
    },
    height: {
      type: "number",
      default: 300,
      minimum: 100
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CHART_DATA_SERIES_KINDS
});
//# sourceMappingURL=Chart.cjs.map