import { ContainerProps } from '@mui/material';
export declare const CHART_DATA_SERIES_KINDS: string[];
export interface ChartDataSeries<D = Record<string, string | number>> {
    kind: (typeof CHART_DATA_SERIES_KINDS)[number];
    label: string;
    data?: D[];
    xKey?: keyof D;
    yKey?: keyof D;
    color?: string;
}
export type ChartData = ChartDataSeries[];
interface ChartProps extends ContainerProps {
    data?: ChartData;
    loading?: boolean;
    error?: Error | string;
    height?: number;
}
declare const _default: import("@mui/toolpad-core").ToolpadComponent<ChartProps>;
export default _default;
