"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/DataGrid.tsx
var DataGrid_exports = {};
__export(DataGrid_exports, {
  CUSTOM_COLUMN_TYPES: () => CUSTOM_COLUMN_TYPES,
  default: () => DataGrid_default,
  inferColumns: () => inferColumns,
  parseColumns: () => parseColumns
});
module.exports = __toCommonJS(DataGrid_exports);
var import_x_data_grid_pro = require("@mui/x-data-grid-pro");
var import_x_license_pro = require("@mui/x-license-pro");
var React2 = __toESM(require("react"), 1);
var import_toolpad_core = require("@mui/toolpad-core");
var import_material2 = require("@mui/material");
var import_objectKey = require("@mui/toolpad-utils/objectKey");
var import_errors2 = require("@mui/toolpad-utils/errors");
var import_path = require("@mui/toolpad-utils/path");
var import_react_error_boundary = require("react-error-boundary");
var import_numberFormat = require("@mui/toolpad-core/numberFormat");

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/components/ErrorOverlay.tsx
var import_material = require("@mui/material");
var React = __toESM(require("react"), 1);
var import_errors = require("@mui/toolpad-utils/errors");
var import_Error = __toESM(require("@mui/icons-material/Error"), 1);
var OverlayRoot = (0, import_material.styled)("div")(({ theme }) => ({
  position: "absolute",
  inset: "0 0 0 0",
  display: "flex",
  flexDirection: "column",
  alignItems: "center",
  justifyContent: "center",
  borderWidth: 1,
  borderStyle: "solid",
  borderRadius: theme.shape.borderRadius,
  borderColor: theme.palette.divider
}));
function ErrorOverlay({ error }) {
  const errMessage = error ? (0, import_errors.errorFrom)(error).message : null;
  return errMessage ? /* @__PURE__ */ React.createElement(OverlayRoot, null, /* @__PURE__ */ React.createElement(import_material.Typography, { sx: { display: "flex", flexDirection: "row", gap: 1 } }, /* @__PURE__ */ React.createElement(import_Error.default, { fontSize: "small", color: "error" }), "Error"), /* @__PURE__ */ React.createElement(import_material.Typography, { variant: "body2" }, errMessage)) : null;
}

// src/DataGrid.tsx
var LICENSE_INFO = {
  key: "f359d9c0d105599a7d83c3f8d775eca5Tz0xMjMsRT0yNTI0NjA0NDAwMDAwLFM9cHJlbWl1bSxMTT1wZXJwZXR1YWwsS1Y9Mg=="
};
var DEFAULT_COLUMN_TYPES = (0, import_x_data_grid_pro.getGridDefaultColumnTypes)();
function mulberry32(a) {
  return () => {
    let t = a += 1831565813;
    t = Math.imul(t ^ t >>> 15, t | 1);
    t ^= t + Math.imul(t ^ t >>> 7, t | 61);
    return ((t ^ t >>> 14) >>> 0) / 4294967296;
  };
}
function randomBetween(seed, min, max) {
  const random = mulberry32(seed);
  return () => min + (max - min) * random();
}
var SkeletonCell = (0, import_material2.styled)(import_material2.Box)(({ theme }) => ({
  display: "flex",
  flexDirection: "row",
  alignItems: "center",
  borderBottom: `1px solid ${theme.palette.divider}`
}));
function SkeletonLoadingOverlay() {
  const apiRef = (0, import_x_data_grid_pro.useGridApiContext)();
  const rootProps = (0, import_x_data_grid_pro.useGridRootProps)();
  const dimensions = apiRef.current?.getRootDimensions();
  const viewportHeight = dimensions?.viewportInnerSize.height ?? 0;
  const factor = (0, import_x_data_grid_pro.useGridSelector)(apiRef, import_x_data_grid_pro.gridDensityFactorSelector);
  const rowHeight = Math.floor(rootProps.rowHeight * factor);
  const skeletonRowsCount = Math.ceil(viewportHeight / rowHeight);
  const totalWidth = (0, import_x_data_grid_pro.gridColumnsTotalWidthSelector)(apiRef);
  const positions = (0, import_x_data_grid_pro.gridColumnPositionsSelector)(apiRef);
  const inViewportCount = React2.useMemo(
    () => positions.filter((value) => value <= totalWidth).length,
    [totalWidth, positions]
  );
  const columns = apiRef.current.getVisibleColumns().slice(0, inViewportCount);
  const children = React2.useMemo(() => {
    const random = randomBetween(12345, 25, 75);
    const array = [];
    for (let i = 0; i < skeletonRowsCount; i += 1) {
      for (const column of columns) {
        const width = Math.round(random());
        array.push(
          /* @__PURE__ */ React2.createElement(SkeletonCell, { key: `col-${column.field}-${i}`, sx: { justifyContent: column.align } }, /* @__PURE__ */ React2.createElement(import_material2.Skeleton, { sx: { mx: 1 }, width: `${width}%` }))
        );
      }
      array.push(/* @__PURE__ */ React2.createElement(SkeletonCell, { key: `fill-${i}` }));
    }
    return array;
  }, [skeletonRowsCount, columns]);
  const rowsCount = apiRef.current.getRowsCount();
  return rowsCount > 0 ? /* @__PURE__ */ React2.createElement(import_material2.LinearProgress, null) : /* @__PURE__ */ React2.createElement(
    "div",
    {
      style: {
        display: "grid",
        gridTemplateColumns: `${columns.map(({ computedWidth }) => `${computedWidth}px`).join(" ")} 1fr`,
        gridAutoRows: `${rowHeight}px`
      }
    },
    children
  );
}
function inferColumnType(value) {
  if (value instanceof Date) {
    return "dateTime";
  }
  const valueType = typeof value;
  switch (typeof value) {
    case "number":
    case "boolean":
      return valueType;
    case "string":
      try {
        const url = new URL(value);
        if ((0, import_path.hasImageExtension)(url.pathname)) {
          return "image";
        }
        return "link";
      } catch (error) {
        return valueType;
      }
    case "object":
      return "json";
    default:
      return "string";
  }
}
function ImageCell({ field, id, value: src }) {
  const [anchorEl, setAnchorEl] = React2.useState(null);
  const handlePopoverOpen = (event) => {
    setAnchorEl(event.currentTarget);
  };
  const handlePopoverClose = () => {
    setAnchorEl(null);
  };
  const open = Boolean(anchorEl);
  const popoverId = React2.useId();
  const alt = `${field} ${id}`;
  return /* @__PURE__ */ React2.createElement(React2.Fragment, null, /* @__PURE__ */ React2.createElement(
    import_material2.Box,
    {
      "aria-owns": open ? popoverId : void 0,
      "aria-haspopup": "true",
      onMouseEnter: handlePopoverOpen,
      onMouseLeave: handlePopoverClose,
      component: "img",
      src,
      alt,
      sx: { maxWidth: "100%", maxHeight: "100%", objectFit: "contain", py: 1 }
    }
  ), /* @__PURE__ */ React2.createElement(
    import_material2.Popover,
    {
      id: popoverId,
      sx: {
        pointerEvents: "none"
      },
      open,
      anchorEl,
      onClose: handlePopoverClose,
      disableRestoreFocus: true
    },
    /* @__PURE__ */ React2.createElement(
      import_material2.Box,
      {
        component: "img",
        src,
        alt,
        sx: { maxWidth: "60vw", maxHeight: "60vh", objectFit: "contain", m: 1 }
      }
    )
  ));
}
function dateValueGetter({ value }) {
  return typeof value === "number" ? new Date(value) : value;
}
function ComponentErrorFallback({ error }) {
  return /* @__PURE__ */ React2.createElement(import_material2.Typography, { variant: "overline", sx: { color: "error.main", fontSize: "10px" } }, "Code component error", " ", /* @__PURE__ */ React2.createElement(import_material2.Tooltip, { title: error.message }, /* @__PURE__ */ React2.createElement("span", null, "\u2139\uFE0F")));
}
function CustomColumn({ params }) {
  const { value, colDef, row, field } = params;
  const column = colDef;
  const components = (0, import_toolpad_core.useComponents)();
  const Component = components[`codeComponent.${column.codeComponent}`];
  if (!Component) {
    return /* @__PURE__ */ React2.createElement(import_material2.Typography, { variant: "overline", sx: { color: "error.main", fontSize: "10px" } }, "No component selected");
  }
  return /* @__PURE__ */ React2.createElement(import_react_error_boundary.ErrorBoundary, { FallbackComponent: ComponentErrorFallback }, /* @__PURE__ */ React2.createElement(Component, { value, row, field }));
}
var CUSTOM_COLUMN_TYPES = {
  json: {
    valueFormatter: ({ value: cellValue }) => JSON.stringify(cellValue)
  },
  date: {
    extendType: "date",
    valueGetter: dateValueGetter
  },
  dateTime: {
    extendType: "date",
    valueGetter: dateValueGetter
  },
  link: {
    renderCell: ({ value }) => /* @__PURE__ */ React2.createElement(import_material2.Link, { href: value, target: "_blank", rel: "noopener noreferrer nofollow" }, value)
  },
  image: {
    renderCell: ({ value, ...params }) => value ? /* @__PURE__ */ React2.createElement(ImageCell, { value, ...params }) : ""
  },
  codeComponent: {
    renderCell: (params) => {
      return /* @__PURE__ */ React2.createElement(CustomColumn, { params });
    }
  }
};
function inferColumns(rows) {
  if (rows.length < 1) {
    return [];
  }
  const firstRow = rows[0];
  return Object.entries(firstRow).map(([field, value]) => {
    return {
      field,
      type: inferColumnType(value)
    };
  });
}
function parseColumns(columns) {
  return columns.map((column) => {
    if (column.type === "number" && column.numberFormat) {
      return {
        ...column,
        valueFormatter: (0, import_numberFormat.createStringFormatter)(column.numberFormat)
      };
    }
    const customType = column.type ? CUSTOM_COLUMN_TYPES[column.type] : {};
    const type = column.type && column.type in DEFAULT_COLUMN_TYPES ? column.type : void 0;
    return { ...customType, ...column, type };
  });
}
var EMPTY_ROWS = [];
var DataGridComponent = React2.forwardRef(function DataGridComponent2({
  columns: columnsProp,
  rows: rowsProp,
  height: heightProp,
  rowIdField: rowIdFieldProp,
  error: errorProp,
  selection,
  onSelectionChange,
  hideToolbar,
  ...props
}, ref) {
  const nodeRuntime = (0, import_toolpad_core.useNode)();
  const handleResize = React2.useMemo(
    () => (0, import_material2.debounce)((params) => {
      if (!nodeRuntime) {
        return;
      }
      nodeRuntime.updateAppDomConstProp(
        "columns",
        (columns2) => columns2?.map(
          (column) => column.field === params.colDef.field ? { ...column, width: params.width } : column
        )
      );
    }, 500),
    [nodeRuntime]
  );
  React2.useEffect(() => handleResize.clear(), [handleResize]);
  const handleColumnOrderChange = React2.useMemo(
    () => (0, import_material2.debounce)((params) => {
      if (!nodeRuntime) {
        return;
      }
      nodeRuntime.updateAppDomConstProp("columns", (columns2) => {
        if (!columns2) {
          return columns2;
        }
        const old = columns2.find((colDef) => colDef.field === params.column.field);
        if (!old) {
          return columns2;
        }
        const withoutOld = columns2.filter((column) => column.field !== params.column.field);
        return [
          ...withoutOld.slice(0, params.targetIndex),
          old,
          ...withoutOld.slice(params.targetIndex)
        ];
      });
    }, 500),
    [nodeRuntime]
  );
  React2.useEffect(() => handleColumnOrderChange.clear(), [handleColumnOrderChange]);
  const rowsInput = rowsProp || EMPTY_ROWS;
  const hasExplicitRowId = React2.useMemo(() => {
    const hasRowIdField = !!(rowIdFieldProp && rowIdFieldProp !== "id");
    const parsedRows = rowsInput;
    return parsedRows.length === 0 || hasRowIdField || !!parsedRows[0].id;
  }, [rowIdFieldProp, rowsInput]);
  const rows = React2.useMemo(
    () => hasExplicitRowId ? rowsInput : rowsInput.map((row, id) => ({ ...row, id })),
    [hasExplicitRowId, rowsInput]
  );
  const columnsInitRef = React2.useRef(false);
  const hasColumnsDefined = columnsProp && columnsProp.length > 0;
  React2.useEffect(() => {
    if (!nodeRuntime || hasColumnsDefined || rows.length <= 0 || columnsInitRef.current) {
      return;
    }
    let inferredColumns = inferColumns(rows);
    if (!hasExplicitRowId) {
      inferredColumns = inferredColumns.filter((column) => column.field !== "id");
    }
    nodeRuntime.updateAppDomConstProp("columns", inferredColumns);
    columnsInitRef.current = true;
  }, [hasColumnsDefined, rows, nodeRuntime, hasExplicitRowId]);
  const getRowId = React2.useCallback(
    (row) => {
      return rowIdFieldProp && row[rowIdFieldProp] ? row[rowIdFieldProp] : row.id;
    },
    [rowIdFieldProp]
  );
  const onSelectionModelChange = React2.useCallback(
    (ids) => {
      onSelectionChange?.(ids.length > 0 ? rows.find((row) => row.id === ids[0]) : null);
    },
    [rows, onSelectionChange]
  );
  const selectionModel = React2.useMemo(
    () => selection?.id ? [selection.id] : [],
    [selection?.id]
  );
  const columns = React2.useMemo(
    () => columnsProp ? parseColumns(columnsProp) : [],
    [columnsProp]
  );
  const apiRef = (0, import_x_data_grid_pro.useGridApiRef)();
  React2.useEffect(() => {
    apiRef.current.updateColumns(columns);
  }, [apiRef, columns]);
  const gridKey = React2.useMemo(
    () => [(0, import_objectKey.getObjectKey)(getRowId), (0, import_objectKey.getObjectKey)(columns)].join("::"),
    [getRowId, columns]
  );
  const error = errorProp ? (0, import_errors2.errorFrom)(errorProp) : null;
  return /* @__PURE__ */ React2.createElement(import_x_license_pro.Unstable_LicenseInfoProvider, { info: LICENSE_INFO }, /* @__PURE__ */ React2.createElement(
    "div",
    {
      ref,
      style: { height: heightProp, minHeight: "100%", width: "100%", position: "relative" }
    },
    /* @__PURE__ */ React2.createElement(ErrorOverlay, { error }),
    /* @__PURE__ */ React2.createElement(
      "div",
      {
        style: {
          position: "absolute",
          inset: "0 0 0 0",
          visibility: error ? "hidden" : "visible"
        }
      },
      /* @__PURE__ */ React2.createElement(
        import_x_data_grid_pro.DataGridPro,
        {
          apiRef,
          slots: {
            toolbar: hideToolbar ? null : import_x_data_grid_pro.GridToolbar,
            loadingOverlay: SkeletonLoadingOverlay
          },
          onColumnResize: handleResize,
          onColumnOrderChange: handleColumnOrderChange,
          rows,
          columns,
          key: gridKey,
          getRowId,
          onRowSelectionModelChange: onSelectionModelChange,
          rowSelectionModel: selectionModel,
          ...props
        }
      )
    )
  ));
});
var DataGrid_default = (0, import_toolpad_core.createComponent)(DataGridComponent, {
  helperText: "The MUI X [Data Grid](https://mui.com/x/react-data-grid/) component.\n\nThe datagrid lets users display tabular data in a flexible grid.",
  errorProp: "error",
  loadingPropSource: ["rows", "columns"],
  loadingProp: "loading",
  resizableHeightProp: "height",
  argTypes: {
    rows: {
      helperText: "The data to be displayed as rows. Must be an array of objects.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: true,
          properties: {
            id: {
              type: "string"
            }
          },
          required: ["id"]
        }
      }
    },
    columns: {
      helperText: "The columns to be displayed.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: true,
          properties: {
            field: {
              type: "string"
            },
            align: {
              type: "string",
              enum: ["center", "right", "left"]
            }
          },
          required: ["field"]
        }
      },
      control: { type: "GridColumns", bindable: false }
    },
    rowIdField: {
      helperText: "Defines which column contains the [id](https://mui.com/x/react-data-grid/row-definition/#row-identifier) that uniquely identifies each row.",
      type: "string",
      control: { type: "RowIdFieldSelect" },
      label: "Id field"
    },
    selection: {
      helperText: "The currently selected row. Or `null` in case no row has been selected.",
      type: "object",
      default: null,
      onChangeProp: "onSelectionChange",
      tsType: `ThisComponent['rows'][number] | undefined`
    },
    density: {
      helperText: "The [density](https://mui.com/x/react-data-grid/accessibility/#density-prop) of the rows. Possible values are `compact`, `standard`, or `comfortable`.",
      type: "string",
      enum: ["compact", "standard", "comfortable"],
      default: "compact"
    },
    height: {
      type: "number",
      default: 350,
      minimum: 100
    },
    loading: {
      helperText: "Displays a loading animation indicating the datagrid isn't ready to present data yet.",
      type: "boolean"
    },
    hideToolbar: {
      helperText: "Hide the toolbar area that contains the data grid user controls.",
      type: "boolean"
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CUSTOM_COLUMN_TYPES,
  inferColumns,
  parseColumns
});
//# sourceMappingURL=DataGrid.cjs.map