import { DataGridProProps, GridRowsProp, GridColDef, GridColTypeDef } from '@mui/x-data-grid-pro';
import * as React from 'react';
import { NumberFormat } from '@mui/toolpad-core/numberFormat';
export declare const CUSTOM_COLUMN_TYPES: Record<string, GridColTypeDef>;
export interface SerializableGridColumn extends Pick<GridColDef, 'field' | 'type' | 'align' | 'width' | 'headerName'> {
    numberFormat?: NumberFormat;
    codeComponent?: string;
}
export type SerializableGridColumns = SerializableGridColumn[];
export declare function inferColumns(rows: GridRowsProp): SerializableGridColumns;
export declare function parseColumns(columns: SerializableGridColumns): GridColDef[];
interface Selection {
    id?: any;
}
interface ToolpadDataGridProps extends Omit<DataGridProProps, 'columns' | 'rows' | 'error'> {
    rows?: GridRowsProp;
    columns?: SerializableGridColumns;
    height?: number;
    rowIdField?: string;
    error?: Error | string;
    selection?: Selection | null;
    onSelectionChange?: (newSelection?: Selection | null) => void;
    hideToolbar?: boolean;
}
declare const _default: import("@mui/toolpad-core").ToolpadComponent<ToolpadDataGridProps & React.RefAttributes<HTMLDivElement>>;
export default _default;
