"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Image.tsx
var Image_exports = {};
__export(Image_exports, {
  default: () => Image_default
});
module.exports = __toCommonJS(Image_exports);
var import_material2 = require("@mui/material");
var React2 = __toESM(require("react"), 1);
var import_toolpad_core = require("@mui/toolpad-core");

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/components/ErrorOverlay.tsx
var import_material = require("@mui/material");
var React = __toESM(require("react"), 1);
var import_errors = require("@mui/toolpad-utils/errors");
var import_Error = __toESM(require("@mui/icons-material/Error"), 1);
var OverlayRoot = (0, import_material.styled)("div")(({ theme }) => ({
  position: "absolute",
  inset: "0 0 0 0",
  display: "flex",
  flexDirection: "column",
  alignItems: "center",
  justifyContent: "center",
  borderWidth: 1,
  borderStyle: "solid",
  borderRadius: theme.shape.borderRadius,
  borderColor: theme.palette.divider
}));
function ErrorOverlay({ error }) {
  const errMessage = error ? (0, import_errors.errorFrom)(error).message : null;
  return errMessage ? /* @__PURE__ */ React.createElement(OverlayRoot, null, /* @__PURE__ */ React.createElement(import_material.Typography, { sx: { display: "flex", flexDirection: "row", gap: 1 } }, /* @__PURE__ */ React.createElement(import_Error.default, { fontSize: "small", color: "error" }), "Error"), /* @__PURE__ */ React.createElement(import_material.Typography, { variant: "body2" }, errMessage)) : null;
}

// src/Image.tsx
var Img = (0, import_material2.styled)("img")({
  width: "100%",
  height: "100%",
  position: "absolute"
});
function Image({
  sx: sxProp,
  src,
  width,
  height,
  alt,
  loading: loadingProp,
  error: errorProp,
  fit
}) {
  const sx = React2.useMemo(
    () => ({
      ...sxProp,
      width,
      height,
      position: "relative",
      display: "flex",
      alignItems: "center",
      justifyContent: "center"
    }),
    [sxProp, width, height]
  );
  const [imgError, setImgError] = React2.useState(null);
  const [imgLoading, setImgLoading] = React2.useState(false);
  const handleLoad = React2.useCallback(() => {
    setImgLoading(false);
  }, []);
  const handleError = React2.useCallback(() => {
    setImgError(new Error(`Failed to load image "${src}"`));
    setImgLoading(false);
  }, [src]);
  React2.useEffect(() => {
    setImgLoading(true);
    setImgError(null);
  }, [src]);
  const loading = loadingProp || imgLoading;
  const error = errorProp || imgError;
  return /* @__PURE__ */ React2.createElement(import_material2.Box, { sx: { maxWidth: "100%", position: "relative", ...sx } }, /* @__PURE__ */ React2.createElement(ErrorOverlay, { error }), loading && !error ? /* @__PURE__ */ React2.createElement(import_material2.Skeleton, { variant: "rectangular", width, height }) : null, /* @__PURE__ */ React2.createElement(
    Img,
    {
      src,
      alt,
      sx: {
        objectFit: fit,
        visibility: loading || error ? "hidden" : "visible"
      },
      onLoad: handleLoad,
      onError: handleError
    }
  ));
}
var Image_default = (0, import_toolpad_core.createComponent)(Image, {
  helperText: "The Image component lets you display images.",
  layoutDirection: "both",
  loadingPropSource: ["src"],
  loadingProp: "loading",
  errorProp: "error",
  argTypes: {
    src: {
      helperText: "The url of the image. Must resolve to an image file.",
      type: "string"
    },
    alt: {
      helperText: "The `alt` attribute holds a text description of the image. screen readers read this description out to their users so they know what the image means. Alt text is also displayed on the page if the image can't be loaded for some reason: for example, network errors, content blocking, or linkrot.",
      type: "string",
      default: ""
    },
    fit: {
      helperText: "Defines how the image should [resize](https://developer.mozilla.org/en-US/docs/Web/CSS/object-fit) to its container.",
      type: "string",
      enum: ["contain", "cover", "fill", "none", "scale-down"],
      default: "contain"
    },
    width: {
      helperText: "The image width in pixels",
      type: "number",
      default: 400
    },
    height: {
      type: "number",
      default: 300
    },
    loading: {
      helperText: "Displays a loading animation indicating the image is still loading",
      type: "boolean",
      default: false
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});
//# sourceMappingURL=Image.cjs.map