"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/List.tsx
var List_exports = {};
__export(List_exports, {
  default: () => List_default
});
module.exports = __toCommonJS(List_exports);
var React = __toESM(require("react"), 1);
var import_toolpad_core = require("@mui/toolpad-core");
var import_material = require("@mui/material");

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/List.tsx
function List({ itemCount, renderItem, disablePadding = false, sx }) {
  return /* @__PURE__ */ React.createElement(import_material.List, { disablePadding, sx: { width: "100%", ...sx } }, [...Array(itemCount).keys()].map((index) => /* @__PURE__ */ React.createElement(import_material.ListItem, { key: index, disablePadding }, /* @__PURE__ */ React.createElement(import_material.Box, { sx: { width: "100%", p: 0, m: 0 } }, renderItem(`item-${index}`, { i: index })))));
}
var List_default = (0, import_toolpad_core.createComponent)(List, {
  argTypes: {
    itemCount: {
      helperText: "Number of items to render.",
      type: "number",
      default: 3
    },
    renderItem: {
      type: "template",
      control: { type: "layoutSlot" }
    },
    disablePadding: {
      helperText: "If true, vertical padding is removed from the list.",
      type: "boolean"
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});
//# sourceMappingURL=List.cjs.map