"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Paper.tsx
var Paper_exports = {};
__export(Paper_exports, {
  default: () => Paper_default
});
module.exports = __toCommonJS(Paper_exports);
var React = __toESM(require("react"), 1);
var import_material = require("@mui/material");
var import_toolpad_core = require("@mui/toolpad-core");

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/Paper.tsx
function Paper({ children, sx, ...rest }) {
  return /* @__PURE__ */ React.createElement(import_material.Paper, { sx: { padding: 1, width: "100%", ...sx }, ...rest }, children);
}
var Paper_default = (0, import_toolpad_core.createComponent)(Paper, {
  layoutDirection: "vertical",
  argTypes: {
    elevation: {
      helperText: "The [elevation](https://mui.com/material-ui/react-paper/#elevation) can be used to establish a hierarchy between other content. In practical terms, the elevation controls the size of the shadow applied to the surface. In dark mode, raising the elevation also makes the surface lighter.",
      type: "number",
      minimum: 0,
      default: 1
    },
    children: {
      type: "element",
      control: { type: "layoutSlot" }
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});
//# sourceMappingURL=Paper.cjs.map