"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Tabs.tsx
var Tabs_exports = {};
__export(Tabs_exports, {
  default: () => Tabs_default
});
module.exports = __toCommonJS(Tabs_exports);
var React = __toESM(require("react"), 1);
var import_material = require("@mui/material");
var import_toolpad_core = require("@mui/toolpad-core");
function Tabs({ value, onChange, tabs, defaultValue }) {
  return /* @__PURE__ */ React.createElement(
    import_material.Tabs,
    {
      value: value || defaultValue,
      onChange: (event, newValue) => {
        onChange(newValue);
      }
    },
    tabs.map(({ title, name }) => /* @__PURE__ */ React.createElement(import_material.Tab, { label: title, value: name, key: name }))
  );
}
var Tabs_default = (0, import_toolpad_core.createComponent)(Tabs, {
  layoutDirection: "horizontal",
  argTypes: {
    value: {
      type: "string",
      onChangeProp: "onChange",
      defaultValueProp: "defaultValue",
      helperText: "Currently active tab."
    },
    defaultValue: {
      label: "Default active tab",
      type: "string",
      default: "tab-one",
      helperText: "The tab which will be active by default."
    },
    tabs: {
      type: "array",
      default: [
        {
          title: "Tab one",
          name: "tab-one"
        },
        { title: "Tab two", name: "tab-two" },
        { title: "Tab three", name: "tab-three" }
      ],
      helperText: "Tabs configuration object."
    }
  }
});
//# sourceMappingURL=Tabs.cjs.map