"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Text.tsx
var Text_exports = {};
__export(Text_exports, {
  default: () => Text_default
});
module.exports = __toCommonJS(Text_exports);
var React = __toESM(require("react"), 1);
var import_material = require("@mui/material");
var import_toolpad_core = require("@mui/toolpad-core");
var import_Error = __toESM(require("@mui/icons-material/Error"), 1);
var import_errors = require("@mui/toolpad-utils/errors");

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/Text.tsx
var Markdown = React.lazy(async () => import("markdown-to-jsx"));
var StyledTextareaAutosize = (0, import_material.styled)(import_material.TextareaAutosize)(({ theme }) => ({
  width: "100%",
  resize: "none",
  border: "none",
  outline: "none",
  padding: 0,
  ...Object.fromEntries(
    Object.keys(theme.typography).map((variant) => [
      [`&.variant-${variant}`],
      theme.typography[variant]
    ])
  )
}));
var MarkdownContainer = (0, import_material.styled)("div")(({ theme }) => ({
  display: "block",
  width: "100%",
  "&:empty::before, & > span:empty::before": {
    content: '""',
    display: "inline-block"
  },
  "& h1": {
    ...theme.typography.h1,
    marginTop: 16,
    marginBottom: 16
  },
  "& h2": {
    ...theme.typography.h2,
    marginTop: 12,
    marginBottom: 12
  },
  "& h3": {
    ...theme.typography.h3,
    marginTop: 12,
    marginBottom: 12
  },
  "& h4": {
    ...theme.typography.h4,
    marginTop: 12,
    marginBottom: 12
  },
  "& h5": {
    ...theme.typography.h5,
    marginTop: 4,
    marginBottom: 4
  },
  "& h6": {
    ...theme.typography.h6,
    marginTop: 4,
    marginBottom: 4
  },
  "& p": {
    marginTop: 12,
    marginBottom: 12
  },
  "& *:first-child": {
    marginTop: 0
  },
  "& *:last-child": {
    marginBottom: 0
  }
}));
var CodeContainer = (0, import_material.styled)("pre")(({ theme }) => ({
  backgroundColor: theme.palette.grey[200],
  marginLeft: theme.spacing(1),
  marginRight: theme.spacing(1),
  borderRadius: theme.shape.borderRadius,
  padding: theme.spacing(1),
  overflow: "auto"
}));
function parseInput(text) {
  return String(text).replaceAll("\n", "");
}
function ErrorDisplay({ error }) {
  const errMessage = (0, import_errors.errorFrom)(error).message;
  return /* @__PURE__ */ React.createElement(import_material.Typography, { sx: { display: "flex", flexDirection: "row", gap: 1, alignItems: "center" } }, /* @__PURE__ */ React.createElement(import_Error.default, { fontSize: "small", color: "error" }), /* @__PURE__ */ React.createElement("span", null, errMessage));
}
function LinkContent({ value, href, loading, sx }) {
  const content = React.useMemo(() => {
    if (loading) {
      return /* @__PURE__ */ React.createElement(import_material.Skeleton, { variant: "text" });
    }
    return value;
  }, [value, loading]);
  return /* @__PURE__ */ React.createElement(
    import_material.Link,
    {
      href,
      target: "_blank",
      rel: "noopener noreferrer",
      sx: {
        minWidth: loading || !value ? 150 : void 0,
        // Same as Typography
        [`&:empty::before`]: { content: '""', display: "inline-block" },
        overflowWrap: "anywhere",
        ...sx
      }
    },
    content
  );
}
function MarkdownContent({ value, loading, sx }) {
  const loadingFallback = /* @__PURE__ */ React.createElement(import_material.Skeleton, { variant: "text", width: "100%" });
  return /* @__PURE__ */ React.createElement(MarkdownContainer, { sx }, loading ? loadingFallback : /* @__PURE__ */ React.createElement(React.Suspense, { fallback: loadingFallback }, /* @__PURE__ */ React.createElement(
    Markdown,
    {
      options: {
        overrides: {
          a: {
            component: import_material.Link,
            props: {
              target: "_blank",
              rel: "noopener noreferrer"
            }
          },
          pre: {
            component: CodeContainer
          }
        },
        slugify: () => ""
      }
    },
    value
  )));
}
function TextContent({ value, loading, sx, variant }) {
  const [contentEditable, setContentEditable] = React.useState(null);
  const [input, setInput] = React.useState(parseInput(value));
  React.useEffect(() => {
    setInput(parseInput(value));
  }, [value]);
  const nodeRuntime = (0, import_toolpad_core.useNode)();
  return contentEditable ? /* @__PURE__ */ React.createElement(
    StyledTextareaAutosize,
    {
      value: input,
      onChange: (event) => {
        setInput(parseInput(event.target.value));
      },
      onKeyDown: (event) => {
        if (event.key === "Enter") {
          event.preventDefault();
        }
      },
      autoFocus: true,
      onFocus: (event) => {
        event.currentTarget.selectionStart = contentEditable.selectionStart;
        event.currentTarget.selectionEnd = Math.max(
          contentEditable.selectionStart,
          contentEditable.selectionEnd
        );
      },
      onBlur: () => {
        setContentEditable(null);
        if (nodeRuntime) {
          nodeRuntime.updateAppDomConstProp("value", input);
        }
      },
      className: `variant-${variant}`
    }
  ) : /* @__PURE__ */ React.createElement(
    import_material.Typography,
    {
      sx: {
        ...sx,
        width: "100%",
        // This will give it height, even when empty.
        // REMARK: Does it make sense to put it in MUI core?
        [`&:empty::before`]: { content: '""', display: "inline-block" },
        outline: "none",
        whiteSpace: "pre-wrap",
        overflowWrap: "break-word"
      },
      variant,
      onDoubleClick: () => {
        if (nodeRuntime) {
          const selection = window.getSelection();
          setContentEditable({
            selectionStart: selection?.anchorOffset || 0,
            selectionEnd: selection?.focusOffset || 0
          });
        }
      }
    },
    loading ? /* @__PURE__ */ React.createElement(import_material.Skeleton, { variant: "text" }) : input
  );
}
function Text(props) {
  if (props.error) {
    return /* @__PURE__ */ React.createElement(ErrorDisplay, { error: props.error });
  }
  switch (props.mode) {
    case "markdown":
      return /* @__PURE__ */ React.createElement(MarkdownContent, { ...props });
    case "link":
      return /* @__PURE__ */ React.createElement(LinkContent, { ...props });
    case "text":
    default:
      return /* @__PURE__ */ React.createElement(TextContent, { ...props });
  }
}
var Text_default = (0, import_toolpad_core.createComponent)(Text, {
  helperText: "The Text component lets you display text. Text can be rendered in multiple forms: plain, as a link, or as markdown.",
  layoutDirection: "both",
  loadingPropSource: ["value"],
  loadingProp: "loading",
  errorPropSource: ["value"],
  errorProp: "error",
  argTypes: {
    mode: {
      helperText: "Defines how the content is rendered. Either as plain text, markdown, or as a link.",
      type: "string",
      enum: ["text", "markdown", "link"],
      default: "text",
      label: "Mode"
    },
    value: {
      helperText: "The text content.",
      type: "string",
      default: "text",
      label: "Value",
      control: { type: "markdown" }
    },
    href: {
      helperText: "The url that is being linked.",
      type: "string",
      default: "about:blank",
      visible: ({ mode }) => mode === "link"
    },
    variant: {
      helperText: "The MUI typography [variant](https://mui.com/material-ui/customization/typography/#variants) that is used to display the text.",
      type: "string",
      enum: ["h1", "h2", "h3", "h4", "h5", "h6", "subtitle1", "subtitle2", "body1", "body2"],
      default: "body1",
      label: "Variant",
      visible: ({ mode }) => mode === "text"
    },
    loading: {
      helperText: "Displays a loading animation instead of the text. Can be used when the content is not available yet.",
      type: "boolean",
      default: false
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object",
      visible: ({ mode }) => mode !== "markdown"
    }
  }
});
//# sourceMappingURL=Text.cjs.map