// src/PageRow.tsx
import * as React from "react";
import { Box } from "@mui/material";
import { createComponent } from "@mui/toolpad-core";
function PageRow({ layoutColumnSizes = [], gap, children }) {
  const gridAutoColumns = layoutColumnSizes.reduce(
    (acc, layoutColumnSize) => `${acc}${`${acc && " "}minmax(0, ${layoutColumnSize || 1}fr)`}`,
    ""
  );
  return /* @__PURE__ */ React.createElement(
    Box,
    {
      sx: {
        gap,
        display: "grid",
        gridAutoFlow: "column",
        gridAutoColumns
      }
    },
    children
  );
}
var PageRow_default = createComponent(PageRow, {
  argTypes: {
    gap: {
      type: "number",
      default: 1,
      minimum: 1
    },
    children: {
      type: "element",
      control: { type: "slots" }
    }
  }
});

export {
  PageRow_default
};
//# sourceMappingURL=chunk-BYS4CCMJ.js.map