import {
  SX_PROP_HELPER_TEXT
} from "./chunk-Z6S6EGNW.js";

// src/List.tsx
import * as React from "react";
import { createComponent } from "@mui/toolpad-core";
import { Box, List as MuiList, ListItem } from "@mui/material";
function List({ itemCount, renderItem, disablePadding = false, sx }) {
  return /* @__PURE__ */ React.createElement(MuiList, { disablePadding, sx: { width: "100%", ...sx } }, [...Array(itemCount).keys()].map((index) => /* @__PURE__ */ React.createElement(ListItem, { key: index, disablePadding }, /* @__PURE__ */ React.createElement(Box, { sx: { width: "100%", p: 0, m: 0 } }, renderItem(`item-${index}`, { i: index })))));
}
var List_default = createComponent(List, {
  argTypes: {
    itemCount: {
      helperText: "Number of items to render.",
      type: "number",
      default: 3
    },
    renderItem: {
      type: "template",
      control: { type: "layoutSlot" }
    },
    disablePadding: {
      helperText: "If true, vertical padding is removed from the list.",
      type: "boolean"
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

export {
  List_default
};
//# sourceMappingURL=chunk-HYVUKTW4.js.map