// src/components/ErrorOverlay.tsx
import { Typography, styled } from "@mui/material";
import * as React from "react";
import { errorFrom } from "@mui/toolpad-utils/errors";
import ErrorIcon from "@mui/icons-material/Error";
var OverlayRoot = styled("div")(({ theme }) => ({
  position: "absolute",
  inset: "0 0 0 0",
  display: "flex",
  flexDirection: "column",
  alignItems: "center",
  justifyContent: "center",
  borderWidth: 1,
  borderStyle: "solid",
  borderRadius: theme.shape.borderRadius,
  borderColor: theme.palette.divider
}));
function ErrorOverlay({ error }) {
  const errMessage = error ? errorFrom(error).message : null;
  return errMessage ? /* @__PURE__ */ React.createElement(OverlayRoot, null, /* @__PURE__ */ React.createElement(Typography, { sx: { display: "flex", flexDirection: "row", gap: 1 } }, /* @__PURE__ */ React.createElement(ErrorIcon, { fontSize: "small", color: "error" }), "Error"), /* @__PURE__ */ React.createElement(Typography, { variant: "body2" }, errMessage)) : null;
}

export {
  ErrorOverlay
};
//# sourceMappingURL=chunk-NFE6IAQR.js.map