"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  Autocomplete: () => Autocomplete_default,
  Button: () => Button_default,
  CHART_DATA_SERIES_KINDS: () => CHART_DATA_SERIES_KINDS,
  CUSTOM_COLUMN_TYPES: () => CUSTOM_COLUMN_TYPES,
  Chart: () => Chart_default,
  Container: () => Container_default,
  DataGrid: () => DataGrid_default,
  DatePicker: () => DatePicker_default,
  FilePicker: () => FilePicker_default,
  Form: () => Form_default,
  Image: () => Image_default,
  List: () => List_default,
  Metric: () => Metric_default,
  PageColumn: () => PageColumn_default,
  PageRow: () => PageRow_default,
  Paper: () => Paper_default,
  Select: () => Select_default,
  Stack: () => Stack_default,
  Tabs: () => Tabs_default,
  Text: () => Text_default,
  TextField: () => TextField_default,
  inferColumns: () => inferColumns,
  parseColumns: () => parseColumns
});
module.exports = __toCommonJS(src_exports);

// src/PageRow.tsx
var React = __toESM(require("react"), 1);
var import_material = require("@mui/material");
var import_toolpad_core = require("@mui/toolpad-core");
function PageRow({ layoutColumnSizes = [], gap, children }) {
  const gridAutoColumns = layoutColumnSizes.reduce(
    (acc, layoutColumnSize) => `${acc}${`${acc && " "}minmax(0, ${layoutColumnSize || 1}fr)`}`,
    ""
  );
  return /* @__PURE__ */ React.createElement(
    import_material.Box,
    {
      sx: {
        gap,
        display: "grid",
        gridAutoFlow: "column",
        gridAutoColumns
      }
    },
    children
  );
}
var PageRow_default = (0, import_toolpad_core.createComponent)(PageRow, {
  argTypes: {
    gap: {
      type: "number",
      default: 1,
      minimum: 1
    },
    children: {
      type: "element",
      control: { type: "slots" }
    }
  }
});

// src/PageColumn.tsx
var React2 = __toESM(require("react"), 1);
var import_material2 = require("@mui/material");
var import_toolpad_core2 = require("@mui/toolpad-core");
function PageColumn({ gap, children }) {
  return /* @__PURE__ */ React2.createElement(
    import_material2.Box,
    {
      sx: {
        gap,
        display: "grid",
        gridAutoFlow: "row",
        gridAutoRows: "fit-content",
        gridAutoColumns: "100%"
      }
    },
    children
  );
}
var PageColumn_default = (0, import_toolpad_core2.createComponent)(PageColumn, {
  argTypes: {
    gap: {
      type: "number",
      default: 1
    },
    children: {
      type: "element",
      control: { type: "slots" }
    }
  }
});

// src/Stack.tsx
var import_material3 = require("@mui/material");
var import_toolpad_core3 = require("@mui/toolpad-core");

// src/constants.tsx
var SX_PROP_HELPER_TEXT = "The [`sx` prop](https://mui.com/system/getting-started/the-sx-prop/) is used for defining custom styles that have access to the theme. All MUI System properties are available via the `sx` prop. In addition, the `sx` prop allows you to specify any other CSS rules you may need.";

// src/Stack.tsx
var Stack_default = (0, import_toolpad_core3.createComponent)(import_material3.Stack, {
  argTypes: {
    direction: {
      type: "string",
      enum: ["row", "row-reverse", "column", "column-reverse"],
      default: "row"
    },
    alignItems: {
      type: "string",
      enum: ["start", "center", "end", "stretch", "baseline"],
      default: "start"
    },
    justifyContent: {
      type: "string",
      enum: ["start", "center", "end", "space-between", "space-around", "space-evenly"],
      default: "start"
    },
    gap: {
      type: "number",
      default: 2
    },
    margin: {
      type: "number"
    },
    children: {
      type: "element",
      control: { type: "slots" }
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/Autocomplete.tsx
var React4 = __toESM(require("react"), 1);
var import_material5 = require("@mui/material");
var import_toolpad_core5 = require("@mui/toolpad-core");

// src/Form.tsx
var React3 = __toESM(require("react"), 1);
var import_material4 = require("@mui/material");
var import_lab = require("@mui/lab");
var import_toolpad_core4 = require("@mui/toolpad-core");
var import_react_hook_form = require("react-hook-form");
var import_lodash_es = require("lodash-es");
var FormContext = React3.createContext({
  form: null,
  fieldValues: {}
});
function Form({
  children,
  value,
  onChange,
  onSubmit = () => {
  },
  hasResetButton = false,
  formControlsAlign = "end",
  formControlsFullWidth,
  submitButtonText = "Submit",
  mode = "onSubmit",
  hasChrome = true,
  sx,
  ...rest
}) {
  const form = (0, import_react_hook_form.useForm)({ mode });
  const { isSubmitSuccessful } = form.formState;
  const handleSubmit = React3.useCallback(async () => {
    await onSubmit();
  }, [onSubmit]);
  React3.useEffect(() => {
    form.reset();
  }, [form, isSubmitSuccessful]);
  React3.useEffect(() => {
    onChange(form.getValues());
  }, [form, onChange]);
  React3.useEffect(() => {
    const formSubscription = form.watch((newValue) => {
      onChange(newValue);
    });
    return () => formSubscription.unsubscribe();
  }, [form, onChange]);
  const handleReset = React3.useCallback(() => {
    form.reset();
  }, [form]);
  const formContextValue = React3.useMemo(
    () => ({ form, fieldValues: value }),
    // form never changes so also use formState as dependency to update context when form state changes
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [form, form.formState, value]
  );
  return /* @__PURE__ */ React3.createElement(FormContext.Provider, { value: formContextValue }, hasChrome ? /* @__PURE__ */ React3.createElement(import_material4.Container, { disableGutters: true, sx, ...rest }, /* @__PURE__ */ React3.createElement("form", { onSubmit: form.handleSubmit(handleSubmit), onReset: handleReset }, children, /* @__PURE__ */ React3.createElement(
    import_material4.Box,
    {
      sx: {
        display: "flex",
        flexDirection: "row",
        justifyContent: formControlsAlign,
        pt: 1
      }
    },
    /* @__PURE__ */ React3.createElement(
      import_material4.Stack,
      {
        direction: "row",
        spacing: 1,
        sx: { flex: formControlsFullWidth ? 1 : "0 1 auto" }
      },
      hasResetButton ? /* @__PURE__ */ React3.createElement(
        import_lab.LoadingButton,
        {
          type: "reset",
          color: "secondary",
          variant: "contained",
          sx: { flex: formControlsFullWidth ? 1 : "0 1 auto" }
        },
        "Reset"
      ) : null,
      /* @__PURE__ */ React3.createElement(
        import_lab.LoadingButton,
        {
          type: "submit",
          color: "primary",
          variant: "contained",
          loading: form.formState.isSubmitting,
          sx: { flex: formControlsFullWidth ? 1 : "0 1 auto" }
        },
        submitButtonText
      )
    )
  ))) : children);
}
var Form_default = (0, import_toolpad_core4.createComponent)(Form, {
  argTypes: {
    children: {
      type: "element",
      control: { type: "layoutSlot" }
    },
    value: {
      helperText: "The value that is controlled by this form.",
      type: "object",
      default: {},
      onChangeProp: "onChange"
    },
    onSubmit: {
      helperText: "Add logic to be executed when the user submits the form.",
      type: "event"
    },
    formControlsAlign: {
      type: "string",
      enum: ["start", "center", "end"],
      default: "end",
      label: "Form controls alignment",
      control: { type: "HorizontalAlign" }
    },
    formControlsFullWidth: {
      helperText: "Whether the form controls should occupy all available horizontal space.",
      type: "boolean",
      default: false
    },
    submitButtonText: {
      helperText: "Submit button text.",
      type: "string",
      default: "Submit"
    },
    hasResetButton: {
      helperText: "Show button to reset form values.",
      type: "boolean",
      default: false
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});
function useFormInput({
  name,
  label,
  value,
  onChange,
  emptyValue,
  defaultValue,
  validationProps
}) {
  const { isRequired, minLength, maxLength, isInvalid } = validationProps;
  const { form, fieldValues } = React3.useContext(FormContext);
  const nodeRuntime = (0, import_toolpad_core4.useNode)();
  const fieldName = name || nodeRuntime?.nodeName;
  const fallbackName = React3.useId();
  const formInputName = fieldName || fallbackName;
  const formInputDisplayName = label || name || "Field";
  const formInputError = formInputName ? form?.formState.errors[formInputName] : void 0;
  const previousDefaultValueRef = React3.useRef(defaultValue);
  React3.useEffect(() => {
    if (form && defaultValue !== previousDefaultValueRef.current) {
      onChange(defaultValue);
      form.setValue(formInputName, defaultValue);
      previousDefaultValueRef.current = defaultValue;
    }
  }, [form, onChange, defaultValue, formInputName]);
  const isInitialForm = Object.keys(fieldValues).length === 0;
  React3.useEffect(() => {
    if (form) {
      if (!fieldValues[formInputName] && defaultValue && isInitialForm) {
        onChange(defaultValue || emptyValue);
        form.setValue(formInputName, defaultValue || emptyValue);
      } else if (value !== fieldValues[formInputName]) {
        onChange(fieldValues[formInputName] || emptyValue);
      }
    }
  }, [defaultValue, emptyValue, fieldValues, form, isInitialForm, formInputName, onChange, value]);
  const previousFormInputNameRef = React3.useRef(formInputName);
  React3.useEffect(() => {
    const previousFormInputName = previousFormInputNameRef.current;
    if (form && previousFormInputName !== formInputName) {
      form.unregister(previousFormInputName);
      previousFormInputNameRef.current = formInputName;
    }
  }, [form, formInputName]);
  const previousManualValidationPropsRef = React3.useRef(validationProps);
  React3.useEffect(() => {
    if (form && !(0, import_lodash_es.isEqual)(validationProps, previousManualValidationPropsRef.current) && form.formState.dirtyFields[formInputName]) {
      form.trigger(formInputName);
      previousManualValidationPropsRef.current = validationProps;
    }
  }, [form, formInputName, validationProps]);
  const handleFormInputChange = React3.useCallback(
    (newValue) => {
      if (form) {
        form.setValue(formInputName, newValue, {
          shouldValidate: true,
          shouldDirty: true,
          shouldTouch: true
        });
      }
      onChange(newValue);
    },
    [form, formInputName, onChange]
  );
  const renderFormInput = React3.useCallback(
    (element) => form ? /* @__PURE__ */ React3.createElement(
      import_react_hook_form.Controller,
      {
        name: formInputName,
        control: form.control,
        rules: {
          required: isRequired ? `${formInputDisplayName} is required.` : false,
          ...minLength && {
            minLength: {
              value: minLength,
              message: `${formInputDisplayName} must have at least ${minLength} characters.`
            }
          },
          ...maxLength && {
            maxLength: {
              value: maxLength,
              message: `${formInputDisplayName} must have no more than ${maxLength} characters.`
            }
          },
          validate: () => !isInvalid || `${formInputDisplayName} is invalid.`
        },
        render: () => element
      }
    ) : element,
    [form, formInputDisplayName, formInputName, isInvalid, isRequired, maxLength, minLength]
  );
  return {
    onFormInputChange: handleFormInputChange,
    formInputError,
    renderFormInput
  };
}
function withComponentForm(InputComponent) {
  return function ComponentWithForm(props) {
    const { form } = React3.useContext(FormContext);
    const [componentFormValue, setComponentFormValue] = React3.useState({});
    const inputElement = /* @__PURE__ */ React3.createElement(InputComponent, { ...props });
    return form ? inputElement : /* @__PURE__ */ React3.createElement(
      Form,
      {
        value: componentFormValue,
        onChange: setComponentFormValue,
        mode: "onBlur",
        hasChrome: false
      },
      inputElement
    );
  };
}
var FORM_INPUT_ARG_TYPES = {
  name: {
    helperText: "Name of this input. Used as a reference in form data.",
    type: "string"
  },
  isRequired: {
    helperText: "Whether the input is required to have a value.",
    type: "boolean",
    default: false,
    category: "validation"
  },
  isInvalid: {
    helperText: "Whether the input value is invalid.",
    type: "boolean",
    default: false,
    category: "validation"
  }
};
var FORM_TEXT_INPUT_ARG_TYPES = {
  minLength: {
    helperText: "Minimum value length.",
    type: "number",
    minimum: 0,
    maximum: 512,
    default: 0,
    category: "validation"
  },
  maxLength: {
    helperText: "Maximum value length.",
    type: "number",
    minimum: 0,
    maximum: 512,
    default: 0,
    category: "validation"
  }
};

// src/Autocomplete.tsx
function Autocomplete({
  options,
  label,
  onChange,
  value,
  isRequired,
  minLength,
  maxLength,
  isInvalid,
  sx,
  ...rest
}) {
  const [selectedVal, setSelectedVal] = React4.useState(null);
  const { onFormInputChange, formInputError, renderFormInput } = useFormInput({
    name: rest.name,
    label,
    value,
    onChange,
    emptyValue: null,
    validationProps: { isRequired, minLength, maxLength, isInvalid }
  });
  const getValue = React4.useCallback((selection) => {
    if (!selection) {
      return null;
    }
    if (typeof selection === "string") {
      return selection;
    }
    if (typeof selection === "object") {
      return selection?.value ?? selection?.label ?? null;
    }
    return null;
  }, []);
  const getOptionLabel = React4.useCallback((option) => {
    if (!option) {
      return "";
    }
    if (typeof option === "string") {
      return option;
    }
    if (typeof option === "object") {
      return option?.label ?? "";
    }
    return "";
  }, []);
  const handleChange = React4.useCallback(
    (event, selection) => {
      const newValue = getValue(selection);
      onFormInputChange(newValue);
      setSelectedVal(selection);
    },
    [getValue, onFormInputChange]
  );
  React4.useEffect(() => {
    if (!value) {
      setSelectedVal(null);
    }
  }, [value]);
  return renderFormInput(
    /* @__PURE__ */ React4.createElement(
      import_material5.Autocomplete,
      {
        onChange: handleChange,
        options: options ?? [],
        isOptionEqualToValue: (option, selectedValue) => getValue(option) === getValue(selectedValue),
        getOptionLabel,
        value: selectedVal,
        renderInput: (params) => /* @__PURE__ */ React4.createElement(
          import_material5.TextField,
          {
            ...params,
            label,
            variant: "outlined",
            ...formInputError && {
              error: Boolean(formInputError),
              helperText: formInputError.message || ""
            }
          }
        ),
        sx: { ...!rest.fullWidth && !value ? { width: 120 } : {}, ...sx },
        ...rest
      }
    )
  );
}
var FormWrappedAutocomplete = withComponentForm(Autocomplete);
var Autocomplete_default = (0, import_toolpad_core5.createComponent)(FormWrappedAutocomplete, {
  layoutDirection: "both",
  loadingProp: "loading",
  argTypes: {
    options: {
      helperText: "The options available to search from.",
      type: "array",
      default: [],
      control: {
        type: "SelectOptions"
      }
    },
    value: {
      helperText: "The value of the autocomplete.",
      type: "string",
      onChangeProp: "onChange",
      default: ""
    },
    label: {
      helperText: "The label to display for the autocomplete.",
      type: "string",
      default: "Search\u2026"
    },
    fullWidth: {
      helperText: "If true, the autocomplete will take up the full width of its container.",
      type: "boolean",
      default: true
    },
    size: {
      helperText: "The size of the autocomplete. One of `small`, `medium`, or `large`.",
      type: "string",
      enum: ["small", "medium", "large"],
      default: "small"
    },
    loading: {
      helperText: "If true, the autocomplete will display a loading indicator.",
      type: "boolean"
    },
    disabled: {
      helperText: "If true, the autocomplete will be disabled.",
      type: "boolean"
    },
    ...FORM_INPUT_ARG_TYPES,
    ...FORM_TEXT_INPUT_ARG_TYPES,
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/Text.tsx
var React5 = __toESM(require("react"), 1);
var import_material6 = require("@mui/material");
var import_toolpad_core6 = require("@mui/toolpad-core");
var import_Error = __toESM(require("@mui/icons-material/Error"), 1);
var import_errors = require("@mui/toolpad-utils/errors");
var Markdown = React5.lazy(async () => import("markdown-to-jsx"));
var StyledTextareaAutosize = (0, import_material6.styled)(import_material6.TextareaAutosize)(({ theme }) => ({
  width: "100%",
  resize: "none",
  border: "none",
  outline: "none",
  padding: 0,
  ...Object.fromEntries(
    Object.keys(theme.typography).map((variant) => [
      [`&.variant-${variant}`],
      theme.typography[variant]
    ])
  )
}));
var MarkdownContainer = (0, import_material6.styled)("div")(({ theme }) => ({
  display: "block",
  width: "100%",
  "&:empty::before, & > span:empty::before": {
    content: '""',
    display: "inline-block"
  },
  "& h1": {
    ...theme.typography.h1,
    marginTop: 16,
    marginBottom: 16
  },
  "& h2": {
    ...theme.typography.h2,
    marginTop: 12,
    marginBottom: 12
  },
  "& h3": {
    ...theme.typography.h3,
    marginTop: 12,
    marginBottom: 12
  },
  "& h4": {
    ...theme.typography.h4,
    marginTop: 12,
    marginBottom: 12
  },
  "& h5": {
    ...theme.typography.h5,
    marginTop: 4,
    marginBottom: 4
  },
  "& h6": {
    ...theme.typography.h6,
    marginTop: 4,
    marginBottom: 4
  },
  "& p": {
    marginTop: 12,
    marginBottom: 12
  },
  "& *:first-child": {
    marginTop: 0
  },
  "& *:last-child": {
    marginBottom: 0
  }
}));
var CodeContainer = (0, import_material6.styled)("pre")(({ theme }) => ({
  backgroundColor: theme.palette.grey[200],
  marginLeft: theme.spacing(1),
  marginRight: theme.spacing(1),
  borderRadius: theme.shape.borderRadius,
  padding: theme.spacing(1),
  overflow: "auto"
}));
function parseInput(text) {
  return String(text).replaceAll("\n", "");
}
function ErrorDisplay({ error }) {
  const errMessage = (0, import_errors.errorFrom)(error).message;
  return /* @__PURE__ */ React5.createElement(import_material6.Typography, { sx: { display: "flex", flexDirection: "row", gap: 1, alignItems: "center" } }, /* @__PURE__ */ React5.createElement(import_Error.default, { fontSize: "small", color: "error" }), /* @__PURE__ */ React5.createElement("span", null, errMessage));
}
function LinkContent({ value, href, loading, sx }) {
  const content = React5.useMemo(() => {
    if (loading) {
      return /* @__PURE__ */ React5.createElement(import_material6.Skeleton, { variant: "text" });
    }
    return value;
  }, [value, loading]);
  return /* @__PURE__ */ React5.createElement(
    import_material6.Link,
    {
      href,
      target: "_blank",
      rel: "noopener noreferrer",
      sx: {
        minWidth: loading || !value ? 150 : void 0,
        // Same as Typography
        [`&:empty::before`]: { content: '""', display: "inline-block" },
        overflowWrap: "anywhere",
        ...sx
      }
    },
    content
  );
}
function MarkdownContent({ value, loading, sx }) {
  const loadingFallback = /* @__PURE__ */ React5.createElement(import_material6.Skeleton, { variant: "text", width: "100%" });
  return /* @__PURE__ */ React5.createElement(MarkdownContainer, { sx }, loading ? loadingFallback : /* @__PURE__ */ React5.createElement(React5.Suspense, { fallback: loadingFallback }, /* @__PURE__ */ React5.createElement(
    Markdown,
    {
      options: {
        overrides: {
          a: {
            component: import_material6.Link,
            props: {
              target: "_blank",
              rel: "noopener noreferrer"
            }
          },
          pre: {
            component: CodeContainer
          }
        },
        slugify: () => ""
      }
    },
    value
  )));
}
function TextContent({ value, loading, sx, variant }) {
  const [contentEditable, setContentEditable] = React5.useState(null);
  const [input, setInput] = React5.useState(parseInput(value));
  React5.useEffect(() => {
    setInput(parseInput(value));
  }, [value]);
  const nodeRuntime = (0, import_toolpad_core6.useNode)();
  return contentEditable ? /* @__PURE__ */ React5.createElement(
    StyledTextareaAutosize,
    {
      value: input,
      onChange: (event) => {
        setInput(parseInput(event.target.value));
      },
      onKeyDown: (event) => {
        if (event.key === "Enter") {
          event.preventDefault();
        }
      },
      autoFocus: true,
      onFocus: (event) => {
        event.currentTarget.selectionStart = contentEditable.selectionStart;
        event.currentTarget.selectionEnd = Math.max(
          contentEditable.selectionStart,
          contentEditable.selectionEnd
        );
      },
      onBlur: () => {
        setContentEditable(null);
        if (nodeRuntime) {
          nodeRuntime.updateAppDomConstProp("value", input);
        }
      },
      className: `variant-${variant}`
    }
  ) : /* @__PURE__ */ React5.createElement(
    import_material6.Typography,
    {
      sx: {
        ...sx,
        width: "100%",
        // This will give it height, even when empty.
        // REMARK: Does it make sense to put it in MUI core?
        [`&:empty::before`]: { content: '""', display: "inline-block" },
        outline: "none",
        whiteSpace: "pre-wrap",
        overflowWrap: "break-word"
      },
      variant,
      onDoubleClick: () => {
        if (nodeRuntime) {
          const selection = window.getSelection();
          setContentEditable({
            selectionStart: selection?.anchorOffset || 0,
            selectionEnd: selection?.focusOffset || 0
          });
        }
      }
    },
    loading ? /* @__PURE__ */ React5.createElement(import_material6.Skeleton, { variant: "text" }) : input
  );
}
function Text(props) {
  if (props.error) {
    return /* @__PURE__ */ React5.createElement(ErrorDisplay, { error: props.error });
  }
  switch (props.mode) {
    case "markdown":
      return /* @__PURE__ */ React5.createElement(MarkdownContent, { ...props });
    case "link":
      return /* @__PURE__ */ React5.createElement(LinkContent, { ...props });
    case "text":
    default:
      return /* @__PURE__ */ React5.createElement(TextContent, { ...props });
  }
}
var Text_default = (0, import_toolpad_core6.createComponent)(Text, {
  helperText: "The Text component lets you display text. Text can be rendered in multiple forms: plain, as a link, or as markdown.",
  layoutDirection: "both",
  loadingPropSource: ["value"],
  loadingProp: "loading",
  errorPropSource: ["value"],
  errorProp: "error",
  argTypes: {
    mode: {
      helperText: "Defines how the content is rendered. Either as plain text, markdown, or as a link.",
      type: "string",
      enum: ["text", "markdown", "link"],
      default: "text",
      label: "Mode"
    },
    value: {
      helperText: "The text content.",
      type: "string",
      default: "text",
      label: "Value",
      control: { type: "markdown" }
    },
    href: {
      helperText: "The url that is being linked.",
      type: "string",
      default: "about:blank",
      visible: ({ mode }) => mode === "link"
    },
    variant: {
      helperText: "The MUI typography [variant](https://mui.com/material-ui/customization/typography/#variants) that is used to display the text.",
      type: "string",
      enum: ["h1", "h2", "h3", "h4", "h5", "h6", "subtitle1", "subtitle2", "body1", "body2"],
      default: "body1",
      label: "Variant",
      visible: ({ mode }) => mode === "text"
    },
    loading: {
      helperText: "Displays a loading animation instead of the text. Can be used when the content is not available yet.",
      type: "boolean",
      default: false
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object",
      visible: ({ mode }) => mode !== "markdown"
    }
  }
});

// src/Button.tsx
var React6 = __toESM(require("react"), 1);
var import_lab2 = require("@mui/lab");
var import_toolpad_core7 = require("@mui/toolpad-core");
function Button({ content, ...rest }) {
  return /* @__PURE__ */ React6.createElement(import_lab2.LoadingButton, { ...rest }, content);
}
var Button_default = (0, import_toolpad_core7.createComponent)(Button, {
  helperText: "The Material UI [Button](https://mui.com/material-ui/react-button/) component.\n\nButtons allow users to take actions, and make choices, with a single tap.",
  layoutDirection: "both",
  argTypes: {
    onClick: {
      helperText: "Add logic to be executed when the user clicks the button.",
      type: "event"
    },
    content: {
      helperText: "Will appear as the text content of the button.",
      type: "string",
      default: "Button Text"
    },
    variant: {
      helperText: "One of the available Material UI Button [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `contained`, `outlined` or `text`",
      type: "string",
      enum: ["contained", "outlined", "text"],
      default: "contained"
    },
    size: {
      helperText: "The size of the component. One of `small`, `medium`, or `large`.",
      type: "string",
      enum: ["small", "medium", "large"],
      default: "small"
    },
    color: {
      helperText: "The theme color of the component.",
      type: "string",
      enum: ["primary", "secondary"],
      default: "primary"
    },
    fullWidth: {
      helperText: "Whether the button should occupy all available horizontal space.",
      type: "boolean"
    },
    loading: {
      helperText: "Displays a loading animation indicating the button isn't interactive yet",
      type: "boolean"
    },
    disabled: {
      helperText: "Whether the button is disabled.",
      type: "boolean"
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/DataGrid.tsx
var import_x_data_grid_pro = require("@mui/x-data-grid-pro");
var import_x_license_pro = require("@mui/x-license-pro");
var React8 = __toESM(require("react"), 1);
var import_toolpad_core8 = require("@mui/toolpad-core");
var import_material8 = require("@mui/material");
var import_objectKey = require("@mui/toolpad-utils/objectKey");
var import_errors3 = require("@mui/toolpad-utils/errors");
var import_path = require("@mui/toolpad-utils/path");
var import_react_error_boundary = require("react-error-boundary");
var import_numberFormat = require("@mui/toolpad-core/numberFormat");

// src/components/ErrorOverlay.tsx
var import_material7 = require("@mui/material");
var React7 = __toESM(require("react"), 1);
var import_errors2 = require("@mui/toolpad-utils/errors");
var import_Error2 = __toESM(require("@mui/icons-material/Error"), 1);
var OverlayRoot = (0, import_material7.styled)("div")(({ theme }) => ({
  position: "absolute",
  inset: "0 0 0 0",
  display: "flex",
  flexDirection: "column",
  alignItems: "center",
  justifyContent: "center",
  borderWidth: 1,
  borderStyle: "solid",
  borderRadius: theme.shape.borderRadius,
  borderColor: theme.palette.divider
}));
function ErrorOverlay({ error }) {
  const errMessage = error ? (0, import_errors2.errorFrom)(error).message : null;
  return errMessage ? /* @__PURE__ */ React7.createElement(OverlayRoot, null, /* @__PURE__ */ React7.createElement(import_material7.Typography, { sx: { display: "flex", flexDirection: "row", gap: 1 } }, /* @__PURE__ */ React7.createElement(import_Error2.default, { fontSize: "small", color: "error" }), "Error"), /* @__PURE__ */ React7.createElement(import_material7.Typography, { variant: "body2" }, errMessage)) : null;
}

// src/DataGrid.tsx
var LICENSE_INFO = {
  key: "f359d9c0d105599a7d83c3f8d775eca5Tz0xMjMsRT0yNTI0NjA0NDAwMDAwLFM9cHJlbWl1bSxMTT1wZXJwZXR1YWwsS1Y9Mg=="
};
var DEFAULT_COLUMN_TYPES = (0, import_x_data_grid_pro.getGridDefaultColumnTypes)();
function mulberry32(a) {
  return () => {
    let t = a += 1831565813;
    t = Math.imul(t ^ t >>> 15, t | 1);
    t ^= t + Math.imul(t ^ t >>> 7, t | 61);
    return ((t ^ t >>> 14) >>> 0) / 4294967296;
  };
}
function randomBetween(seed, min, max) {
  const random = mulberry32(seed);
  return () => min + (max - min) * random();
}
var SkeletonCell = (0, import_material8.styled)(import_material8.Box)(({ theme }) => ({
  display: "flex",
  flexDirection: "row",
  alignItems: "center",
  borderBottom: `1px solid ${theme.palette.divider}`
}));
function SkeletonLoadingOverlay() {
  const apiRef = (0, import_x_data_grid_pro.useGridApiContext)();
  const rootProps = (0, import_x_data_grid_pro.useGridRootProps)();
  const dimensions = apiRef.current?.getRootDimensions();
  const viewportHeight = dimensions?.viewportInnerSize.height ?? 0;
  const factor = (0, import_x_data_grid_pro.useGridSelector)(apiRef, import_x_data_grid_pro.gridDensityFactorSelector);
  const rowHeight = Math.floor(rootProps.rowHeight * factor);
  const skeletonRowsCount = Math.ceil(viewportHeight / rowHeight);
  const totalWidth = (0, import_x_data_grid_pro.gridColumnsTotalWidthSelector)(apiRef);
  const positions = (0, import_x_data_grid_pro.gridColumnPositionsSelector)(apiRef);
  const inViewportCount = React8.useMemo(
    () => positions.filter((value) => value <= totalWidth).length,
    [totalWidth, positions]
  );
  const columns = apiRef.current.getVisibleColumns().slice(0, inViewportCount);
  const children = React8.useMemo(() => {
    const random = randomBetween(12345, 25, 75);
    const array = [];
    for (let i = 0; i < skeletonRowsCount; i += 1) {
      for (const column of columns) {
        const width = Math.round(random());
        array.push(
          /* @__PURE__ */ React8.createElement(SkeletonCell, { key: `col-${column.field}-${i}`, sx: { justifyContent: column.align } }, /* @__PURE__ */ React8.createElement(import_material8.Skeleton, { sx: { mx: 1 }, width: `${width}%` }))
        );
      }
      array.push(/* @__PURE__ */ React8.createElement(SkeletonCell, { key: `fill-${i}` }));
    }
    return array;
  }, [skeletonRowsCount, columns]);
  const rowsCount = apiRef.current.getRowsCount();
  return rowsCount > 0 ? /* @__PURE__ */ React8.createElement(import_material8.LinearProgress, null) : /* @__PURE__ */ React8.createElement(
    "div",
    {
      style: {
        display: "grid",
        gridTemplateColumns: `${columns.map(({ computedWidth }) => `${computedWidth}px`).join(" ")} 1fr`,
        gridAutoRows: `${rowHeight}px`
      }
    },
    children
  );
}
function inferColumnType(value) {
  if (value instanceof Date) {
    return "dateTime";
  }
  const valueType = typeof value;
  switch (typeof value) {
    case "number":
    case "boolean":
      return valueType;
    case "string":
      try {
        const url = new URL(value);
        if ((0, import_path.hasImageExtension)(url.pathname)) {
          return "image";
        }
        return "link";
      } catch (error) {
        return valueType;
      }
    case "object":
      return "json";
    default:
      return "string";
  }
}
function ImageCell({ field, id, value: src }) {
  const [anchorEl, setAnchorEl] = React8.useState(null);
  const handlePopoverOpen = (event) => {
    setAnchorEl(event.currentTarget);
  };
  const handlePopoverClose = () => {
    setAnchorEl(null);
  };
  const open = Boolean(anchorEl);
  const popoverId = React8.useId();
  const alt = `${field} ${id}`;
  return /* @__PURE__ */ React8.createElement(React8.Fragment, null, /* @__PURE__ */ React8.createElement(
    import_material8.Box,
    {
      "aria-owns": open ? popoverId : void 0,
      "aria-haspopup": "true",
      onMouseEnter: handlePopoverOpen,
      onMouseLeave: handlePopoverClose,
      component: "img",
      src,
      alt,
      sx: { maxWidth: "100%", maxHeight: "100%", objectFit: "contain", py: 1 }
    }
  ), /* @__PURE__ */ React8.createElement(
    import_material8.Popover,
    {
      id: popoverId,
      sx: {
        pointerEvents: "none"
      },
      open,
      anchorEl,
      onClose: handlePopoverClose,
      disableRestoreFocus: true
    },
    /* @__PURE__ */ React8.createElement(
      import_material8.Box,
      {
        component: "img",
        src,
        alt,
        sx: { maxWidth: "60vw", maxHeight: "60vh", objectFit: "contain", m: 1 }
      }
    )
  ));
}
function dateValueGetter({ value }) {
  return typeof value === "number" ? new Date(value) : value;
}
function ComponentErrorFallback({ error }) {
  return /* @__PURE__ */ React8.createElement(import_material8.Typography, { variant: "overline", sx: { color: "error.main", fontSize: "10px" } }, "Code component error", " ", /* @__PURE__ */ React8.createElement(import_material8.Tooltip, { title: error.message }, /* @__PURE__ */ React8.createElement("span", null, "\u2139\uFE0F")));
}
function CustomColumn({ params }) {
  const { value, colDef, row, field } = params;
  const column = colDef;
  const components = (0, import_toolpad_core8.useComponents)();
  const Component = components[`codeComponent.${column.codeComponent}`];
  if (!Component) {
    return /* @__PURE__ */ React8.createElement(import_material8.Typography, { variant: "overline", sx: { color: "error.main", fontSize: "10px" } }, "No component selected");
  }
  return /* @__PURE__ */ React8.createElement(import_react_error_boundary.ErrorBoundary, { FallbackComponent: ComponentErrorFallback }, /* @__PURE__ */ React8.createElement(Component, { value, row, field }));
}
var CUSTOM_COLUMN_TYPES = {
  json: {
    valueFormatter: ({ value: cellValue }) => JSON.stringify(cellValue)
  },
  date: {
    extendType: "date",
    valueGetter: dateValueGetter
  },
  dateTime: {
    extendType: "date",
    valueGetter: dateValueGetter
  },
  link: {
    renderCell: ({ value }) => /* @__PURE__ */ React8.createElement(import_material8.Link, { href: value, target: "_blank", rel: "noopener noreferrer nofollow" }, value)
  },
  image: {
    renderCell: ({ value, ...params }) => value ? /* @__PURE__ */ React8.createElement(ImageCell, { value, ...params }) : ""
  },
  codeComponent: {
    renderCell: (params) => {
      return /* @__PURE__ */ React8.createElement(CustomColumn, { params });
    }
  }
};
function inferColumns(rows) {
  if (rows.length < 1) {
    return [];
  }
  const firstRow = rows[0];
  return Object.entries(firstRow).map(([field, value]) => {
    return {
      field,
      type: inferColumnType(value)
    };
  });
}
function parseColumns(columns) {
  return columns.map((column) => {
    if (column.type === "number" && column.numberFormat) {
      return {
        ...column,
        valueFormatter: (0, import_numberFormat.createStringFormatter)(column.numberFormat)
      };
    }
    const customType = column.type ? CUSTOM_COLUMN_TYPES[column.type] : {};
    const type = column.type && column.type in DEFAULT_COLUMN_TYPES ? column.type : void 0;
    return { ...customType, ...column, type };
  });
}
var EMPTY_ROWS = [];
var DataGridComponent = React8.forwardRef(function DataGridComponent2({
  columns: columnsProp,
  rows: rowsProp,
  height: heightProp,
  rowIdField: rowIdFieldProp,
  error: errorProp,
  selection,
  onSelectionChange,
  hideToolbar,
  ...props
}, ref) {
  const nodeRuntime = (0, import_toolpad_core8.useNode)();
  const handleResize = React8.useMemo(
    () => (0, import_material8.debounce)((params) => {
      if (!nodeRuntime) {
        return;
      }
      nodeRuntime.updateAppDomConstProp(
        "columns",
        (columns2) => columns2?.map(
          (column) => column.field === params.colDef.field ? { ...column, width: params.width } : column
        )
      );
    }, 500),
    [nodeRuntime]
  );
  React8.useEffect(() => handleResize.clear(), [handleResize]);
  const handleColumnOrderChange = React8.useMemo(
    () => (0, import_material8.debounce)((params) => {
      if (!nodeRuntime) {
        return;
      }
      nodeRuntime.updateAppDomConstProp("columns", (columns2) => {
        if (!columns2) {
          return columns2;
        }
        const old = columns2.find((colDef) => colDef.field === params.column.field);
        if (!old) {
          return columns2;
        }
        const withoutOld = columns2.filter((column) => column.field !== params.column.field);
        return [
          ...withoutOld.slice(0, params.targetIndex),
          old,
          ...withoutOld.slice(params.targetIndex)
        ];
      });
    }, 500),
    [nodeRuntime]
  );
  React8.useEffect(() => handleColumnOrderChange.clear(), [handleColumnOrderChange]);
  const rowsInput = rowsProp || EMPTY_ROWS;
  const hasExplicitRowId = React8.useMemo(() => {
    const hasRowIdField = !!(rowIdFieldProp && rowIdFieldProp !== "id");
    const parsedRows = rowsInput;
    return parsedRows.length === 0 || hasRowIdField || !!parsedRows[0].id;
  }, [rowIdFieldProp, rowsInput]);
  const rows = React8.useMemo(
    () => hasExplicitRowId ? rowsInput : rowsInput.map((row, id) => ({ ...row, id })),
    [hasExplicitRowId, rowsInput]
  );
  const columnsInitRef = React8.useRef(false);
  const hasColumnsDefined = columnsProp && columnsProp.length > 0;
  React8.useEffect(() => {
    if (!nodeRuntime || hasColumnsDefined || rows.length <= 0 || columnsInitRef.current) {
      return;
    }
    let inferredColumns = inferColumns(rows);
    if (!hasExplicitRowId) {
      inferredColumns = inferredColumns.filter((column) => column.field !== "id");
    }
    nodeRuntime.updateAppDomConstProp("columns", inferredColumns);
    columnsInitRef.current = true;
  }, [hasColumnsDefined, rows, nodeRuntime, hasExplicitRowId]);
  const getRowId = React8.useCallback(
    (row) => {
      return rowIdFieldProp && row[rowIdFieldProp] ? row[rowIdFieldProp] : row.id;
    },
    [rowIdFieldProp]
  );
  const onSelectionModelChange = React8.useCallback(
    (ids) => {
      onSelectionChange?.(ids.length > 0 ? rows.find((row) => row.id === ids[0]) : null);
    },
    [rows, onSelectionChange]
  );
  const selectionModel = React8.useMemo(
    () => selection?.id ? [selection.id] : [],
    [selection?.id]
  );
  const columns = React8.useMemo(
    () => columnsProp ? parseColumns(columnsProp) : [],
    [columnsProp]
  );
  const apiRef = (0, import_x_data_grid_pro.useGridApiRef)();
  React8.useEffect(() => {
    apiRef.current.updateColumns(columns);
  }, [apiRef, columns]);
  const gridKey = React8.useMemo(
    () => [(0, import_objectKey.getObjectKey)(getRowId), (0, import_objectKey.getObjectKey)(columns)].join("::"),
    [getRowId, columns]
  );
  const error = errorProp ? (0, import_errors3.errorFrom)(errorProp) : null;
  return /* @__PURE__ */ React8.createElement(import_x_license_pro.Unstable_LicenseInfoProvider, { info: LICENSE_INFO }, /* @__PURE__ */ React8.createElement(
    "div",
    {
      ref,
      style: { height: heightProp, minHeight: "100%", width: "100%", position: "relative" }
    },
    /* @__PURE__ */ React8.createElement(ErrorOverlay, { error }),
    /* @__PURE__ */ React8.createElement(
      "div",
      {
        style: {
          position: "absolute",
          inset: "0 0 0 0",
          visibility: error ? "hidden" : "visible"
        }
      },
      /* @__PURE__ */ React8.createElement(
        import_x_data_grid_pro.DataGridPro,
        {
          apiRef,
          slots: {
            toolbar: hideToolbar ? null : import_x_data_grid_pro.GridToolbar,
            loadingOverlay: SkeletonLoadingOverlay
          },
          onColumnResize: handleResize,
          onColumnOrderChange: handleColumnOrderChange,
          rows,
          columns,
          key: gridKey,
          getRowId,
          onRowSelectionModelChange: onSelectionModelChange,
          rowSelectionModel: selectionModel,
          ...props
        }
      )
    )
  ));
});
var DataGrid_default = (0, import_toolpad_core8.createComponent)(DataGridComponent, {
  helperText: "The MUI X [Data Grid](https://mui.com/x/react-data-grid/) component.\n\nThe datagrid lets users display tabular data in a flexible grid.",
  errorProp: "error",
  loadingPropSource: ["rows", "columns"],
  loadingProp: "loading",
  resizableHeightProp: "height",
  argTypes: {
    rows: {
      helperText: "The data to be displayed as rows. Must be an array of objects.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: true,
          properties: {
            id: {
              type: "string"
            }
          },
          required: ["id"]
        }
      }
    },
    columns: {
      helperText: "The columns to be displayed.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: "object",
          additionalProperties: true,
          properties: {
            field: {
              type: "string"
            },
            align: {
              type: "string",
              enum: ["center", "right", "left"]
            }
          },
          required: ["field"]
        }
      },
      control: { type: "GridColumns", bindable: false }
    },
    rowIdField: {
      helperText: "Defines which column contains the [id](https://mui.com/x/react-data-grid/row-definition/#row-identifier) that uniquely identifies each row.",
      type: "string",
      control: { type: "RowIdFieldSelect" },
      label: "Id field"
    },
    selection: {
      helperText: "The currently selected row. Or `null` in case no row has been selected.",
      type: "object",
      default: null,
      onChangeProp: "onSelectionChange",
      tsType: `ThisComponent['rows'][number] | undefined`
    },
    density: {
      helperText: "The [density](https://mui.com/x/react-data-grid/accessibility/#density-prop) of the rows. Possible values are `compact`, `standard`, or `comfortable`.",
      type: "string",
      enum: ["compact", "standard", "comfortable"],
      default: "compact"
    },
    height: {
      type: "number",
      default: 350,
      minimum: 100
    },
    loading: {
      helperText: "Displays a loading animation indicating the datagrid isn't ready to present data yet.",
      type: "boolean"
    },
    hideToolbar: {
      helperText: "Hide the toolbar area that contains the data grid user controls.",
      type: "boolean"
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/Chart.tsx
var React9 = __toESM(require("react"), 1);
var import_toolpad_core9 = require("@mui/toolpad-core");
var import_material9 = require("@mui/material");
var import_recharts = require("recharts");
var import_errors4 = require("@mui/toolpad-utils/errors");
var CHART_DATA_SERIES_KINDS = ["line", "bar", "area", "scatter"];
function getBarChartDataSeriesNormalizedYKey(dataSeries, index) {
  return `${dataSeries.label}-${dataSeries.yKey}-${index}`;
}
function Chart({ data = [], loading, error, height, sx }) {
  const xValues = React9.useMemo(
    () => data.flatMap((dataSeries) => {
      if (!dataSeries.xKey || !dataSeries.data) {
        return [];
      }
      return dataSeries.data.map((dataSeriesPoint) => dataSeriesPoint[dataSeries.xKey]);
    }).filter((value, index, array) => array.indexOf(value) === index).sort(
      (a, b) => typeof a === "number" && typeof b === "number" ? a - b : 0
    ),
    [data]
  );
  const barChartData = React9.useMemo(() => {
    return xValues.map((xValue) => {
      const yValues = data.reduce((acc, dataSeries, index) => {
        if (dataSeries.kind !== "bar" || !dataSeries.xKey || !dataSeries.yKey) {
          return acc;
        }
        const point = (dataSeries.data || []).find(
          (dataSeriesPoint) => dataSeriesPoint[dataSeries.xKey] === xValue
        );
        return {
          ...acc,
          [getBarChartDataSeriesNormalizedYKey(dataSeries, index)]: point ? point[dataSeries.yKey] : 0
        };
      }, {});
      return {
        x: xValue,
        ...yValues
      };
    });
  }, [data, xValues]);
  const hasNonNumberXValues = xValues.some((xValue) => typeof xValue !== "number");
  const displayError = error ? (0, import_errors4.errorFrom)(error) : null;
  const isDataVisible = !loading && !displayError;
  return /* @__PURE__ */ React9.createElement(import_material9.Container, { disableGutters: true, sx: { ...sx, position: "relative" }, "aria-busy": loading }, /* @__PURE__ */ React9.createElement(import_recharts.ResponsiveContainer, { width: "100%", height }, /* @__PURE__ */ React9.createElement(import_recharts.ComposedChart, { data: barChartData, margin: { top: 20, right: 80 } }, isDataVisible ? /* @__PURE__ */ React9.createElement(React9.Fragment, null, /* @__PURE__ */ React9.createElement(import_recharts.CartesianGrid, { strokeDasharray: "3 3" }), /* @__PURE__ */ React9.createElement(
    import_recharts.XAxis,
    {
      dataKey: "x",
      type: hasNonNumberXValues ? "category" : "number",
      allowDuplicatedCategory: false,
      domain: hasNonNumberXValues ? void 0 : [Math.min(...xValues), Math.max(...xValues)]
    }
  ), /* @__PURE__ */ React9.createElement(import_recharts.YAxis, { width: 80 }), /* @__PURE__ */ React9.createElement(import_recharts.Tooltip, null), /* @__PURE__ */ React9.createElement(import_recharts.Legend, null), data.map((dataSeries, index) => {
    if (!dataSeries.data || dataSeries.data.length === 0 || !dataSeries.xKey || !dataSeries.yKey) {
      return null;
    }
    const key = `${dataSeries.label}-${index}`;
    const normalizedData = dataSeries.data.map((dataSeriesPoint) => ({
      x: dataSeriesPoint[dataSeries.xKey],
      [dataSeries.yKey]: dataSeriesPoint[dataSeries.yKey]
    })).sort(
      (a, b) => typeof a[dataSeries.xKey] === "number" && typeof b[dataSeries.xKey] === "number" ? a[dataSeries.xKey] - b[dataSeries.xKey] : 0
    );
    switch (dataSeries.kind) {
      case "bar":
        return /* @__PURE__ */ React9.createElement(
          import_recharts.Bar,
          {
            key,
            dataKey: getBarChartDataSeriesNormalizedYKey(dataSeries, index),
            name: dataSeries.label,
            barSize: 20,
            fill: dataSeries.color
          }
        );
      case "area":
        return /* @__PURE__ */ React9.createElement(
          import_recharts.Area,
          {
            key,
            type: "monotone",
            data: normalizedData,
            dataKey: dataSeries.yKey,
            name: dataSeries.label,
            stroke: dataSeries.color,
            fill: dataSeries.color
          }
        );
      case "scatter":
        return /* @__PURE__ */ React9.createElement(
          import_recharts.Scatter,
          {
            key,
            data: normalizedData,
            dataKey: dataSeries.yKey,
            name: dataSeries.label,
            fill: dataSeries.color
          }
        );
      default:
        return /* @__PURE__ */ React9.createElement(
          import_recharts.Line,
          {
            key,
            type: "monotone",
            data: normalizedData,
            dataKey: dataSeries.yKey,
            name: dataSeries.label,
            stroke: dataSeries.color
          }
        );
    }
  })) : null)), /* @__PURE__ */ React9.createElement(ErrorOverlay, { error: displayError }), loading && !error ? /* @__PURE__ */ React9.createElement(
    import_material9.Skeleton,
    {
      sx: { position: "absolute", inset: "0 0 0 0" },
      variant: "rectangular",
      width: "100%",
      height
    }
  ) : null);
}
var Chart_default = (0, import_toolpad_core9.createComponent)(Chart, {
  loadingProp: "loading",
  loadingPropSource: ["data"],
  errorProp: "error",
  resizableHeightProp: "height",
  argTypes: {
    data: {
      helperText: "The data to be displayed.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: "object",
          properties: {
            kind: {
              type: "string",
              enum: CHART_DATA_SERIES_KINDS,
              default: "line"
            },
            label: {
              type: "string"
            },
            data: {
              type: "object",
              default: []
            },
            xKey: {
              type: "string"
            },
            yKey: {
              type: "string"
            },
            color: {
              type: "string"
            }
          }
        }
      },
      control: { type: "ChartData", bindable: false }
    },
    height: {
      type: "number",
      default: 300,
      minimum: 100
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/TextField.tsx
var React10 = __toESM(require("react"), 1);
var import_material10 = require("@mui/material");
var import_toolpad_core10 = require("@mui/toolpad-core");
function TextField2({
  defaultValue,
  onChange,
  value,
  isRequired,
  minLength,
  maxLength,
  isInvalid,
  ...rest
}) {
  const { onFormInputChange, formInputError, renderFormInput } = useFormInput({
    name: rest.name,
    label: rest.label,
    value,
    onChange,
    emptyValue: "",
    defaultValue,
    validationProps: { isRequired, minLength, maxLength, isInvalid }
  });
  const handleChange = React10.useCallback(
    (event) => {
      const newValue = event.target.value;
      onFormInputChange(newValue);
    },
    [onFormInputChange]
  );
  return renderFormInput(
    /* @__PURE__ */ React10.createElement(
      import_material10.TextField,
      {
        value,
        onChange: handleChange,
        ...rest,
        ...formInputError && {
          error: Boolean(formInputError),
          helperText: formInputError.message || ""
        }
      }
    )
  );
}
var FormWrappedTextField = withComponentForm(TextField2);
var TextField_default = (0, import_toolpad_core10.createComponent)(FormWrappedTextField, {
  helperText: "The TextField component lets you input a text value.",
  layoutDirection: "both",
  argTypes: {
    value: {
      helperText: "The value that is controlled by this text input.",
      type: "string",
      default: "",
      onChangeProp: "onChange",
      defaultValueProp: "defaultValue"
    },
    defaultValue: {
      helperText: "A default value for when the input is still empty.",
      type: "string",
      default: ""
    },
    label: {
      helperText: 'A label that describes the content of the text field. e.g. "First name".',
      type: "string"
    },
    variant: {
      helperText: "One of the available MUI TextField [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `outlined`, `filled` or `standard`",
      type: "string",
      enum: ["outlined", "filled", "standard"],
      default: "outlined"
    },
    size: {
      helperText: "The size of the input. One of `small`, or `medium`.",
      type: "string",
      enum: ["small", "medium"],
      default: "small"
    },
    fullWidth: {
      helperText: "Whether the input should occupy all available horizontal space.",
      type: "boolean"
    },
    disabled: {
      helperText: "Whether the input is disabled.",
      type: "boolean"
    },
    ...FORM_INPUT_ARG_TYPES,
    ...FORM_TEXT_INPUT_ARG_TYPES,
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/Select.tsx
var React11 = __toESM(require("react"), 1);
var import_material11 = require("@mui/material");
var import_toolpad_core11 = require("@mui/toolpad-core");
function Select({
  options,
  value,
  onChange,
  fullWidth,
  sx,
  defaultValue,
  isRequired,
  isInvalid,
  ...rest
}) {
  const { onFormInputChange, formInputError, renderFormInput } = useFormInput({
    name: rest.name,
    label: rest.label,
    value,
    onChange,
    defaultValue,
    validationProps: { isRequired, isInvalid }
  });
  const id = React11.useId();
  const handleChange = React11.useCallback(
    (event) => {
      const newValue = event.target.value;
      onFormInputChange(newValue);
    },
    [onFormInputChange]
  );
  const renderedOptions = React11.useMemo(
    () => options.map((option, i) => {
      const parsedOption = option && typeof option === "object" ? option : { value: String(option) };
      return /* @__PURE__ */ React11.createElement(import_material11.MenuItem, { key: parsedOption.value ?? `${id}::${i}`, value: parsedOption.value }, String(parsedOption.label ?? parsedOption.value));
    }),
    [id, options]
  );
  return renderFormInput(
    /* @__PURE__ */ React11.createElement(
      import_material11.TextField,
      {
        ...rest,
        value,
        onChange: handleChange,
        select: true,
        fullWidth: true,
        sx: { ...!fullWidth && !value ? { width: 120 } : {}, ...sx },
        ...formInputError && {
          error: Boolean(formInputError),
          helperText: formInputError.message || ""
        }
      },
      renderedOptions
    )
  );
}
var FormWrappedSelect = withComponentForm(Select);
var Select_default = (0, import_toolpad_core11.createComponent)(FormWrappedSelect, {
  helperText: "The Select component lets you select a value from a set of options.",
  layoutDirection: "both",
  loadingPropSource: ["value", "options"],
  loadingProp: "disabled",
  argTypes: {
    options: {
      helperText: "The available options to select from.",
      type: "array",
      schema: {
        type: "array",
        items: {
          type: ["object", "string"],
          additionalProperties: true,
          properties: {
            value: {
              type: "string"
            },
            label: {
              type: "string"
            }
          },
          required: ["value"]
        }
      },
      default: [],
      control: { type: "SelectOptions" }
    },
    value: {
      helperText: "The currently selected value.",
      type: "string",
      default: "",
      onChangeProp: "onChange",
      defaultValueProp: "defaultValue"
    },
    defaultValue: {
      helperText: "A default value.",
      type: "string",
      default: ""
    },
    label: {
      helperText: 'A label that describes the option that can be selected. e.g. "Country".',
      type: "string",
      default: ""
    },
    variant: {
      helperText: "One of the available MUI TextField [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `outlined`, `filled` or `standard`",
      type: "string",
      enum: ["outlined", "filled", "standard"],
      default: "outlined"
    },
    size: {
      helperText: "The size of the select. One of `small`, or `medium`.",
      type: "string",
      enum: ["small", "medium"],
      default: "small"
    },
    fullWidth: {
      helperText: "Whether the select should occupy all available horizontal space.",
      type: "boolean"
    },
    disabled: {
      helperText: "Whether the select is disabled.",
      type: "boolean"
    },
    ...FORM_INPUT_ARG_TYPES,
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/List.tsx
var React12 = __toESM(require("react"), 1);
var import_toolpad_core12 = require("@mui/toolpad-core");
var import_material12 = require("@mui/material");
function List({ itemCount, renderItem, disablePadding = false, sx }) {
  return /* @__PURE__ */ React12.createElement(import_material12.List, { disablePadding, sx: { width: "100%", ...sx } }, [...Array(itemCount).keys()].map((index) => /* @__PURE__ */ React12.createElement(import_material12.ListItem, { key: index, disablePadding }, /* @__PURE__ */ React12.createElement(import_material12.Box, { sx: { width: "100%", p: 0, m: 0 } }, renderItem(`item-${index}`, { i: index })))));
}
var List_default = (0, import_toolpad_core12.createComponent)(List, {
  argTypes: {
    itemCount: {
      helperText: "Number of items to render.",
      type: "number",
      default: 3
    },
    renderItem: {
      type: "template",
      control: { type: "layoutSlot" }
    },
    disablePadding: {
      helperText: "If true, vertical padding is removed from the list.",
      type: "boolean"
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/Paper.tsx
var React13 = __toESM(require("react"), 1);
var import_material13 = require("@mui/material");
var import_toolpad_core13 = require("@mui/toolpad-core");
function Paper({ children, sx, ...rest }) {
  return /* @__PURE__ */ React13.createElement(import_material13.Paper, { sx: { padding: 1, width: "100%", ...sx }, ...rest }, children);
}
var Paper_default = (0, import_toolpad_core13.createComponent)(Paper, {
  layoutDirection: "vertical",
  argTypes: {
    elevation: {
      helperText: "The [elevation](https://mui.com/material-ui/react-paper/#elevation) can be used to establish a hierarchy between other content. In practical terms, the elevation controls the size of the shadow applied to the surface. In dark mode, raising the elevation also makes the surface lighter.",
      type: "number",
      minimum: 0,
      default: 1
    },
    children: {
      type: "element",
      control: { type: "layoutSlot" }
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/Image.tsx
var import_material14 = require("@mui/material");
var React14 = __toESM(require("react"), 1);
var import_toolpad_core14 = require("@mui/toolpad-core");
var Img = (0, import_material14.styled)("img")({
  width: "100%",
  height: "100%",
  position: "absolute"
});
function Image({
  sx: sxProp,
  src,
  width,
  height,
  alt,
  loading: loadingProp,
  error: errorProp,
  fit
}) {
  const sx = React14.useMemo(
    () => ({
      ...sxProp,
      width,
      height,
      position: "relative",
      display: "flex",
      alignItems: "center",
      justifyContent: "center"
    }),
    [sxProp, width, height]
  );
  const [imgError, setImgError] = React14.useState(null);
  const [imgLoading, setImgLoading] = React14.useState(false);
  const handleLoad = React14.useCallback(() => {
    setImgLoading(false);
  }, []);
  const handleError = React14.useCallback(() => {
    setImgError(new Error(`Failed to load image "${src}"`));
    setImgLoading(false);
  }, [src]);
  React14.useEffect(() => {
    setImgLoading(true);
    setImgError(null);
  }, [src]);
  const loading = loadingProp || imgLoading;
  const error = errorProp || imgError;
  return /* @__PURE__ */ React14.createElement(import_material14.Box, { sx: { maxWidth: "100%", position: "relative", ...sx } }, /* @__PURE__ */ React14.createElement(ErrorOverlay, { error }), loading && !error ? /* @__PURE__ */ React14.createElement(import_material14.Skeleton, { variant: "rectangular", width, height }) : null, /* @__PURE__ */ React14.createElement(
    Img,
    {
      src,
      alt,
      sx: {
        objectFit: fit,
        visibility: loading || error ? "hidden" : "visible"
      },
      onLoad: handleLoad,
      onError: handleError
    }
  ));
}
var Image_default = (0, import_toolpad_core14.createComponent)(Image, {
  helperText: "The Image component lets you display images.",
  layoutDirection: "both",
  loadingPropSource: ["src"],
  loadingProp: "loading",
  errorProp: "error",
  argTypes: {
    src: {
      helperText: "The url of the image. Must resolve to an image file.",
      type: "string"
    },
    alt: {
      helperText: "The `alt` attribute holds a text description of the image. screen readers read this description out to their users so they know what the image means. Alt text is also displayed on the page if the image can't be loaded for some reason: for example, network errors, content blocking, or linkrot.",
      type: "string",
      default: ""
    },
    fit: {
      helperText: "Defines how the image should [resize](https://developer.mozilla.org/en-US/docs/Web/CSS/object-fit) to its container.",
      type: "string",
      enum: ["contain", "cover", "fill", "none", "scale-down"],
      default: "contain"
    },
    width: {
      helperText: "The image width in pixels",
      type: "number",
      default: 400
    },
    height: {
      type: "number",
      default: 300
    },
    loading: {
      helperText: "Displays a loading animation indicating the image is still loading",
      type: "boolean",
      default: false
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/DatePicker.tsx
var React15 = __toESM(require("react"), 1);
var import_LocalizationProvider = require("@mui/x-date-pickers/LocalizationProvider");
var import_DesktopDatePicker = require("@mui/x-date-pickers/DesktopDatePicker");
var import_AdapterDayjs = require("@mui/x-date-pickers/AdapterDayjs");
var import_toolpad_core15 = require("@mui/toolpad-core");
var import_dayjs = __toESM(require("dayjs"), 1);
var LOCALE_LOADERS = new Map(
  // jest is choking on this dynamic import
  process.env.NODE_ENV === "test" ? [] : [
    ["en", () => import("dayjs/locale/en")],
    ["nl", () => import("dayjs/locale/nl")],
    ["fr", () => import("dayjs/locale/fr")]
    // TODO...
  ]
);
var handlers = /* @__PURE__ */ new Set();
var loadedLocale;
function trygetLoadableLocale(locale) {
  const load = LOCALE_LOADERS.get(locale);
  if (load) {
    return { locale, load };
  }
  return null;
}
function getLoadableLocale() {
  if (typeof window === "undefined") {
    return null;
  }
  const languages = window.navigator.languages;
  for (const locale of languages) {
    const { language } = new Intl.Locale(locale);
    const result = trygetLoadableLocale(locale) || trygetLoadableLocale(language);
    if (result) {
      return result;
    }
  }
  return null;
}
var loadableLocale = getLoadableLocale();
if (loadableLocale) {
  loadableLocale.load().then(() => {
    loadedLocale = loadableLocale.locale;
    handlers.forEach((handler) => handler());
  });
}
function subscribeLocaleLoader(cb) {
  handlers.add(cb);
  return () => handlers.delete(cb);
}
function getSnapshot() {
  return loadedLocale;
}
function DatePicker({
  format,
  onChange,
  value: valueProp,
  defaultValue: defaultValueProp,
  isRequired,
  isInvalid,
  ...rest
}) {
  const { onFormInputChange, formInputError, renderFormInput } = useFormInput({
    name: rest.name,
    label: rest.label,
    value: valueProp,
    onChange,
    defaultValue: defaultValueProp,
    emptyValue: null,
    validationProps: { isRequired, isInvalid }
  });
  const handleChange = React15.useMemo(
    () => onFormInputChange ? (newValue) => {
      const stringValue = newValue?.format("YYYY-MM-DD") || "";
      onFormInputChange(stringValue);
    } : void 0,
    [onFormInputChange]
  );
  const adapterLocale = React15.useSyncExternalStore(subscribeLocaleLoader, getSnapshot);
  const value = React15.useMemo(
    () => typeof valueProp === "string" ? (0, import_dayjs.default)(valueProp) : valueProp,
    [valueProp]
  );
  const defaultValue = React15.useMemo(
    () => typeof defaultValueProp === "string" ? (0, import_dayjs.default)(defaultValueProp) : defaultValueProp,
    [defaultValueProp]
  );
  return /* @__PURE__ */ React15.createElement(import_LocalizationProvider.LocalizationProvider, { dateAdapter: import_AdapterDayjs.AdapterDayjs, adapterLocale }, renderFormInput(
    /* @__PURE__ */ React15.createElement(
      import_DesktopDatePicker.DesktopDatePicker,
      {
        ...rest,
        format: format || "L",
        value: value || null,
        onChange: handleChange,
        defaultValue,
        slotProps: {
          textField: {
            fullWidth: rest.fullWidth,
            variant: rest.variant,
            size: rest.size,
            sx: rest.sx,
            ...formInputError && {
              error: Boolean(formInputError),
              helperText: formInputError.message || ""
            }
          }
        }
      }
    )
  ));
}
var FormWrappedDatePicker = withComponentForm(DatePicker);
var DatePicker_default = (0, import_toolpad_core15.createComponent)(FormWrappedDatePicker, {
  helperText: "The MUI X [Date Picker](https://mui.com/x/react-date-pickers/date-picker/) component.\n\nThe date picker lets the user select a date.",
  argTypes: {
    value: {
      helperText: "The currently selected date.",
      type: "string",
      default: "",
      onChangeProp: "onChange",
      defaultValueProp: "defaultValue"
    },
    format: {
      helperText: "The [format](https://day.js.org/docs/en/display/format) of the date in the UI. The value for the bindings will always be in the `YYYY-MM-DD` format. Leave empty to let the end-user locale define the format.",
      type: "string",
      default: ""
    },
    defaultValue: {
      helperText: "A default value for the date picker.",
      type: "string",
      default: ""
    },
    label: {
      helperText: 'A label that describes the content of the date picker. e.g. "Arrival date".',
      type: "string"
    },
    name: {
      helperText: "Name of this element. Used as a reference in form data.",
      type: "string"
    },
    variant: {
      helperText: "One of the available MUI TextField [variants](https://mui.com/material-ui/react-button/#basic-button). Possible values are `outlined`, `filled` or `standard`",
      type: "string",
      enum: ["outlined", "filled", "standard"],
      default: "outlined"
    },
    size: {
      helperText: "The size of the component. One of `small`, or `medium`.",
      type: "string",
      enum: ["small", "medium"],
      default: "small"
    },
    fullWidth: {
      helperText: "Whether the button should occupy all available horizontal space.",
      type: "boolean"
    },
    disabled: {
      helperText: "The date picker is disabled.",
      type: "boolean"
    },
    ...FORM_INPUT_ARG_TYPES,
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object"
    }
  }
});

// src/FilePicker.tsx
var React16 = __toESM(require("react"), 1);
var import_material15 = require("@mui/material");
var import_toolpad_core16 = require("@mui/toolpad-core");
var readFile = async (file) => {
  return new Promise((resolve, reject) => {
    const readerBase64 = new FileReader();
    readerBase64.onload = (event) => {
      if (!event.target) {
        reject();
        return;
      }
      resolve(event.target.result);
    };
    readerBase64.readAsDataURL(file);
  });
};
function FilePicker({
  multiple,
  value,
  onChange,
  isRequired,
  isInvalid,
  ...rest
}) {
  const { onFormInputChange, formInputError, renderFormInput } = useFormInput({
    name: rest.name,
    label: rest.label,
    value,
    onChange,
    validationProps: { isRequired, isInvalid }
  });
  const handleChange = async (changeEvent) => {
    const filesPromises = Array.from(changeEvent.target.files || []).map(async (file) => {
      const fullFile = {
        name: file.name,
        type: file.type,
        size: file.size,
        base64: await readFile(file)
      };
      return fullFile;
    });
    const files = await Promise.all(filesPromises);
    onFormInputChange(files);
  };
  return renderFormInput(
    /* @__PURE__ */ React16.createElement(
      import_material15.TextField,
      {
        ...rest,
        type: "file",
        value: void 0,
        onChange: handleChange,
        inputProps: { multiple },
        InputLabelProps: { shrink: true },
        ...formInputError && {
          error: Boolean(formInputError),
          helperText: formInputError.message || ""
        }
      }
    )
  );
}
var FormWrappedFilePicker = withComponentForm(FilePicker);
var FilePicker_default = (0, import_toolpad_core16.createComponent)(FormWrappedFilePicker, {
  helperText: "File Picker component.\nIt allows users to take select and read files.",
  argTypes: {
    value: {
      type: "object",
      visible: false,
      onChangeProp: "onChange"
    },
    label: {
      helperText: 'A label that describes the content of the FilePicker. e.g. "Profile Image".',
      type: "string"
    },
    multiple: {
      helperText: "Whether the FilePicker should accept multiple files.",
      type: "boolean",
      default: true
    },
    disabled: {
      helperText: "Whether the FilePicker is disabled.",
      type: "boolean"
    },
    ...FORM_INPUT_ARG_TYPES,
    sx: {
      type: "object"
    }
  }
});

// src/Tabs.tsx
var React17 = __toESM(require("react"), 1);
var import_material16 = require("@mui/material");
var import_toolpad_core17 = require("@mui/toolpad-core");
function Tabs({ value, onChange, tabs, defaultValue }) {
  return /* @__PURE__ */ React17.createElement(
    import_material16.Tabs,
    {
      value: value || defaultValue,
      onChange: (event, newValue) => {
        onChange(newValue);
      }
    },
    tabs.map(({ title, name }) => /* @__PURE__ */ React17.createElement(import_material16.Tab, { label: title, value: name, key: name }))
  );
}
var Tabs_default = (0, import_toolpad_core17.createComponent)(Tabs, {
  layoutDirection: "horizontal",
  argTypes: {
    value: {
      type: "string",
      onChangeProp: "onChange",
      defaultValueProp: "defaultValue",
      helperText: "Currently active tab."
    },
    defaultValue: {
      label: "Default active tab",
      type: "string",
      default: "tab-one",
      helperText: "The tab which will be active by default."
    },
    tabs: {
      type: "array",
      default: [
        {
          title: "Tab one",
          name: "tab-one"
        },
        { title: "Tab two", name: "tab-two" },
        { title: "Tab three", name: "tab-three" }
      ],
      helperText: "Tabs configuration object."
    }
  }
});

// src/Container.tsx
var React18 = __toESM(require("react"), 1);
var import_material17 = require("@mui/material");
var import_toolpad_core18 = require("@mui/toolpad-core");
function Container3({ children, visible, sx, ...props }) {
  return visible ? /* @__PURE__ */ React18.createElement(import_material17.Container, { disableGutters: true, sx, ...props }, children) : null;
}
var Container_default = (0, import_toolpad_core18.createComponent)(Container3, {
  argTypes: {
    children: {
      type: "element",
      control: { type: "layoutSlot" },
      helperText: "The content of the component."
    },
    visible: {
      type: "boolean",
      default: true,
      helperText: "Control whether container element is visible."
    },
    sx: {
      helperText: SX_PROP_HELPER_TEXT,
      type: "object",
      default: { padding: 1, border: "solid 1px" }
    }
  }
});

// src/Metric.tsx
var React19 = __toESM(require("react"), 1);
var import_material18 = require("@mui/material");
var import_toolpad_core19 = require("@mui/toolpad-core");
var import_numberFormat2 = require("@mui/toolpad-core/numberFormat");
function resolveColor(colorScale, value) {
  const { base, stops = [] } = colorScale;
  let stopValue = -Infinity;
  let color = base;
  for (const stop of stops) {
    if (stop.value > stopValue && value > stop.value) {
      stopValue = stop.value;
      color = stop.color;
    }
  }
  return color;
}
function Metric({
  fullWidth,
  conditionalFormat,
  loading,
  value,
  numberFormat,
  label,
  caption
}) {
  const format = React19.useMemo(() => (0, import_numberFormat2.createFormat)(numberFormat), [numberFormat]);
  const color = React19.useMemo(
    () => conditionalFormat ? resolveColor(conditionalFormat, value) : void 0,
    [conditionalFormat, value]
  );
  return /* @__PURE__ */ React19.createElement(import_material18.Paper, { sx: { p: 2, minWidth: 160, width: fullWidth ? "100%" : void 0 } }, /* @__PURE__ */ React19.createElement(import_material18.Typography, { sx: { fontSize: 14 }, color: "text.secondary", gutterBottom: true, noWrap: true }, label), /* @__PURE__ */ React19.createElement(import_material18.Typography, { variant: "h5", component: "div", color, noWrap: true }, loading ? /* @__PURE__ */ React19.createElement(import_material18.Skeleton, { variant: "text" }) : /* @__PURE__ */ React19.createElement(import_numberFormat2.FormattedNumber, { format }, value)), /* @__PURE__ */ React19.createElement(import_material18.Typography, { variant: "body2", noWrap: true }, caption));
}
var Metric_default = (0, import_toolpad_core19.createComponent)(Metric, {
  helperText: "The Metric component can be used to display a single numerical value. it supports multiple numerical formats such as bytes, currency, percentage... It also supports conditional formatting to adapt the color based on the numerical value.",
  loadingPropSource: ["value"],
  loadingProp: "loading",
  argTypes: {
    label: {
      helperText: "The label to be displayed.",
      type: "string",
      default: "label"
    },
    value: {
      helperText: "The value to be displayed.",
      type: "number",
      default: 0
    },
    numberFormat: {
      helperText: "The number format for the value.",
      label: "Number format",
      type: "object",
      schema: import_numberFormat2.NUMBER_FORMAT_SCHEMA,
      control: {
        type: "NumberFormat"
      }
    },
    caption: {
      helperText: "The caption to be displayed.",
      type: "string",
      default: ""
    },
    conditionalFormat: {
      helperText: "The color of the number, dependent on the value.",
      label: "Conditional format",
      type: "object",
      schema: {
        type: "object",
        properties: {
          base: {
            type: "string"
          },
          stops: {
            type: "array",
            items: {
              type: "object",
              properties: {
                value: {
                  type: "number"
                },
                color: {
                  type: "string"
                }
              },
              required: ["value", "color"]
            }
          }
        },
        required: ["base", "stops"]
      },
      control: {
        type: "ColorScale"
      }
    },
    fullWidth: {
      helperText: "Whether the button should occupy all available horizontal space.",
      type: "boolean"
    }
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Autocomplete,
  Button,
  CHART_DATA_SERIES_KINDS,
  CUSTOM_COLUMN_TYPES,
  Chart,
  Container,
  DataGrid,
  DatePicker,
  FilePicker,
  Form,
  Image,
  List,
  Metric,
  PageColumn,
  PageRow,
  Paper,
  Select,
  Stack,
  Tabs,
  Text,
  TextField,
  inferColumns,
  parseColumns
});
//# sourceMappingURL=index.cjs.map