// src/jsRuntime.tsx
import { hasOwnProperty } from "@mui/toolpad-utils/collections";
var TOOLPAD_LOADING_MARKER = "__TOOLPAD_LOADING_MARKER__";
function evaluateBindable(ctx, bindable, globalScope) {
  if (bindable && typeof bindable === "object") {
    if (hasOwnProperty(bindable, "$$jsExpression")) {
      return ctx.evaluateExpression(bindable.$$jsExpression, globalScope);
    }
    if (hasOwnProperty(bindable, "$$env")) {
      return { value: ctx.getEnv()[bindable.$$env] };
    }
  }
  return { value: bindable };
}

export {
  TOOLPAD_LOADING_MARKER,
  evaluateBindable
};
//# sourceMappingURL=chunk-37XWBP4F.js.map