import {
  createComponent
} from "./chunk-J426TNQ5.js";
import {
  RUNTIME_PROP_NODE_ID,
  RUNTIME_PROP_SLOTS,
  TOOLPAD_COMPONENT
} from "./chunk-4TRYSV22.js";

// src/runtime.tsx
import * as React from "react";
import { ErrorBoundary } from "react-error-boundary";
import * as ReactIs from "react-is";
import { hasOwnProperty } from "@mui/toolpad-utils/collections";
import { createProvidedContext } from "@mui/toolpad-utils/react";
var ResetNodeErrorsKeyContext = React.createContext(0);
var ResetNodeErrorsKeyProvider = ResetNodeErrorsKeyContext.Provider;
var ComponentsContext = React.createContext(null);
var NodeRuntimeContext = React.createContext({
  nodeId: null,
  nodeName: null
});
var CanvasEventsContext = React.createContext(null);
function SlotsWrapper({ children }) {
  return /* @__PURE__ */ React.createElement(React.Fragment, null, children);
}
function PlaceholderWrapper(props) {
  return /* @__PURE__ */ React.createElement(
    "div",
    {
      style: {
        minHeight: 72,
        minWidth: 200
      }
    }
  );
}
function NodeFiberHost({ children }) {
  return children;
}
function NodeRuntimeWrapper({
  nodeId,
  nodeName,
  componentConfig,
  children,
  NodeError
}) {
  const resetNodeErrorsKey = React.useContext(ResetNodeErrorsKeyContext);
  const ErrorFallback = React.useCallback(
    ({ error }) => /* @__PURE__ */ React.createElement(
      NodeFiberHost,
      {
        ...{
          [RUNTIME_PROP_NODE_ID]: nodeId,
          nodeError: error,
          componentConfig
        }
      },
      /* @__PURE__ */ React.createElement(NodeError, { error })
    ),
    [NodeError, componentConfig, nodeId]
  );
  const nodeRuntimeValue = React.useMemo(() => ({ nodeId, nodeName }), [nodeId, nodeName]);
  return /* @__PURE__ */ React.createElement(ErrorBoundary, { resetKeys: [resetNodeErrorsKey], fallbackRender: ErrorFallback }, /* @__PURE__ */ React.createElement(NodeRuntimeContext.Provider, { value: nodeRuntimeValue }, /* @__PURE__ */ React.createElement(
    NodeFiberHost,
    {
      ...{
        [RUNTIME_PROP_NODE_ID]: nodeId,
        componentConfig
      }
    },
    children
  )));
}
function useNode() {
  const { nodeId, nodeName } = React.useContext(NodeRuntimeContext);
  const canvasEvents = React.useContext(CanvasEventsContext);
  return React.useMemo(() => {
    if (!nodeId || !canvasEvents) {
      return null;
    }
    return {
      nodeId,
      nodeName,
      updateAppDomConstProp: (prop, value) => {
        canvasEvents.emit("propUpdated", {
          nodeId,
          prop,
          value
        });
      }
    };
  }, [canvasEvents, nodeId, nodeName]);
}
function Placeholder({ prop, children, hasLayout = false }) {
  const { nodeId } = React.useContext(NodeRuntimeContext);
  if (!nodeId) {
    return /* @__PURE__ */ React.createElement(React.Fragment, null, children);
  }
  const count = React.Children.count(children);
  return count > 0 ? /* @__PURE__ */ React.createElement(React.Fragment, null, children) : /* @__PURE__ */ React.createElement(
    PlaceholderWrapper,
    {
      parentId: nodeId,
      ...{
        [RUNTIME_PROP_SLOTS]: prop,
        slotType: hasLayout ? "layout" : "single"
      }
    }
  );
}
function Slots({ prop, children }) {
  const { nodeId } = React.useContext(NodeRuntimeContext);
  if (!nodeId) {
    return /* @__PURE__ */ React.createElement(React.Fragment, null, children);
  }
  const count = React.Children.count(children);
  return count > 0 ? /* @__PURE__ */ React.createElement(
    SlotsWrapper,
    {
      parentId: nodeId,
      ...{
        [RUNTIME_PROP_SLOTS]: prop,
        slotType: "multiple"
      }
    },
    children
  ) : /* @__PURE__ */ React.createElement(Placeholder, { prop });
}
function isToolpadComponent(maybeComponent) {
  if (!ReactIs.isValidElementType(maybeComponent) || typeof maybeComponent === "string" || !hasOwnProperty(maybeComponent, TOOLPAD_COMPONENT)) {
    return false;
  }
  return true;
}
function getArgTypeDefaultValue(argType) {
  return argType.default ?? argType.defaultValue ?? void 0;
}
function createToolpadComponentThatThrows(error) {
  return createComponent(() => {
    throw error;
  });
}
var [useComponents, ComponentsContextProvider] = createProvidedContext("Components");
function useComponent(id) {
  const components = useComponents();
  return React.useMemo(() => {
    return components?.[id] ?? createToolpadComponentThatThrows(new Error(`Can't find component for "${id}"`));
  }, [components, id]);
}

export {
  ResetNodeErrorsKeyProvider,
  ComponentsContext,
  NodeRuntimeContext,
  CanvasEventsContext,
  NodeRuntimeWrapper,
  useNode,
  Placeholder,
  Slots,
  isToolpadComponent,
  getArgTypeDefaultValue,
  createToolpadComponentThatThrows,
  useComponents,
  ComponentsContextProvider,
  useComponent
};
//# sourceMappingURL=chunk-W7O6LH6J.js.map