"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  ComponentsContext: () => ComponentsContext,
  ComponentsContextProvider: () => ComponentsContextProvider,
  IMAGE_EXTENSIONS: () => IMAGE_EXTENSIONS,
  Placeholder: () => Placeholder,
  RUNTIME_PROP_NODE_ID: () => RUNTIME_PROP_NODE_ID,
  RUNTIME_PROP_SLOTS: () => RUNTIME_PROP_SLOTS,
  Slots: () => Slots,
  TOOLPAD_COMPONENT: () => TOOLPAD_COMPONENT,
  TOOLPAD_COMPONENT_MODE_PROPERTY: () => TOOLPAD_COMPONENT_MODE_PROPERTY,
  TOOLPAD_FUNCTION: () => TOOLPAD_FUNCTION,
  createComponent: () => createComponent,
  createToolpadComponentThatThrows: () => createToolpadComponentThatThrows,
  getArgTypeDefaultValue: () => getArgTypeDefaultValue,
  isToolpadComponent: () => isToolpadComponent,
  useComponent: () => useComponent,
  useComponents: () => useComponents,
  useNode: () => useNode,
  useUrlQueryState: () => useUrlQueryState
});
module.exports = __toCommonJS(src_exports);

// src/runtime.tsx
var React = __toESM(require("react"), 1);
var import_react_error_boundary = require("react-error-boundary");
var ReactIs = __toESM(require("react-is"), 1);
var import_collections = require("@mui/toolpad-utils/collections");
var import_react = require("@mui/toolpad-utils/react");

// src/constants.ts
var RUNTIME_PROP_NODE_ID = "__toolpadNodeId";
var RUNTIME_PROP_SLOTS = "__toolpadSlots";
var TOOLPAD_COMPONENT = Symbol.for("ToolpadComponent");
var TOOLPAD_FUNCTION = Symbol.for("ToolpadFunction");
var TOOLPAD_COMPONENT_MODE_PROPERTY = "ToolpadComponentMode";
var IMAGE_EXTENSIONS = ["jpg", "jpeg", "png", "gif", "svg", "webp"];

// src/browser.tsx
function createComponent(Component, config) {
  if (config?.argTypes) {
    for (const [name, argType] of Object.entries(config.argTypes)) {
      const maybeLegacyArgtype = argType;
      if (maybeLegacyArgtype.typeDef) {
        console.warn(`Detected deprecated argType definition for "${name}".`);
        Object.assign(maybeLegacyArgtype, maybeLegacyArgtype.typeDef);
        delete maybeLegacyArgtype.typeDef;
      }
    }
  }
  return Object.assign(Component, {
    [TOOLPAD_COMPONENT]: config || { argTypes: {} }
  });
}

// src/runtime.tsx
var ResetNodeErrorsKeyContext = React.createContext(0);
var ResetNodeErrorsKeyProvider = ResetNodeErrorsKeyContext.Provider;
var ComponentsContext = React.createContext(null);
var NodeRuntimeContext = React.createContext({
  nodeId: null,
  nodeName: null
});
var CanvasEventsContext = React.createContext(null);
function SlotsWrapper({ children }) {
  return /* @__PURE__ */ React.createElement(React.Fragment, null, children);
}
function PlaceholderWrapper(props) {
  return /* @__PURE__ */ React.createElement(
    "div",
    {
      style: {
        minHeight: 72,
        minWidth: 200
      }
    }
  );
}
function useNode() {
  const { nodeId, nodeName } = React.useContext(NodeRuntimeContext);
  const canvasEvents = React.useContext(CanvasEventsContext);
  return React.useMemo(() => {
    if (!nodeId || !canvasEvents) {
      return null;
    }
    return {
      nodeId,
      nodeName,
      updateAppDomConstProp: (prop, value) => {
        canvasEvents.emit("propUpdated", {
          nodeId,
          prop,
          value
        });
      }
    };
  }, [canvasEvents, nodeId, nodeName]);
}
function Placeholder({ prop, children, hasLayout = false }) {
  const { nodeId } = React.useContext(NodeRuntimeContext);
  if (!nodeId) {
    return /* @__PURE__ */ React.createElement(React.Fragment, null, children);
  }
  const count = React.Children.count(children);
  return count > 0 ? /* @__PURE__ */ React.createElement(React.Fragment, null, children) : /* @__PURE__ */ React.createElement(
    PlaceholderWrapper,
    {
      parentId: nodeId,
      ...{
        [RUNTIME_PROP_SLOTS]: prop,
        slotType: hasLayout ? "layout" : "single"
      }
    }
  );
}
function Slots({ prop, children }) {
  const { nodeId } = React.useContext(NodeRuntimeContext);
  if (!nodeId) {
    return /* @__PURE__ */ React.createElement(React.Fragment, null, children);
  }
  const count = React.Children.count(children);
  return count > 0 ? /* @__PURE__ */ React.createElement(
    SlotsWrapper,
    {
      parentId: nodeId,
      ...{
        [RUNTIME_PROP_SLOTS]: prop,
        slotType: "multiple"
      }
    },
    children
  ) : /* @__PURE__ */ React.createElement(Placeholder, { prop });
}
function isToolpadComponent(maybeComponent) {
  if (!ReactIs.isValidElementType(maybeComponent) || typeof maybeComponent === "string" || !(0, import_collections.hasOwnProperty)(maybeComponent, TOOLPAD_COMPONENT)) {
    return false;
  }
  return true;
}
function getArgTypeDefaultValue(argType) {
  return argType.default ?? argType.defaultValue ?? void 0;
}
function createToolpadComponentThatThrows(error) {
  return createComponent(() => {
    throw error;
  });
}
var [useComponents, ComponentsContextProvider] = (0, import_react.createProvidedContext)("Components");
function useComponent(id) {
  const components = useComponents();
  return React.useMemo(() => {
    return components?.[id] ?? createToolpadComponentThatThrows(new Error(`Can't find component for "${id}"`));
  }, [components, id]);
}

// src/useUrlQueryState.ts
var React2 = __toESM(require("react"), 1);
function getLocationUrl() {
  return new URL((window.top ?? window).location.href);
}
function useUrlQueryState(param, defaultValue = "") {
  const [value, setValue] = React2.useState(defaultValue);
  const isInitialized = React2.useRef(false);
  React2.useEffect(() => {
    const url = getLocationUrl();
    const currentUrlValue = url.searchParams.get(param);
    if (isInitialized.current) {
      if (currentUrlValue !== value) {
        if (currentUrlValue === defaultValue) {
          url.searchParams.delete(param);
        } else {
          url.searchParams.set(param, value);
        }
        window.history.pushState(null, "", String(url));
      }
    } else {
      if (typeof currentUrlValue === "string") {
        setValue(currentUrlValue);
      }
      isInitialized.current = true;
    }
  }, [param, value, defaultValue]);
  React2.useEffect(() => {
    const handlePopState = () => {
      const url = getLocationUrl();
      const urlQueryValue = url.searchParams.get(param);
      setValue(urlQueryValue ?? defaultValue);
    };
    window.addEventListener("popstate", handlePopState);
    return () => {
      window.removeEventListener("popstate", handlePopState);
    };
  }, [param, defaultValue]);
  return [value, setValue];
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ComponentsContext,
  ComponentsContextProvider,
  IMAGE_EXTENSIONS,
  Placeholder,
  RUNTIME_PROP_NODE_ID,
  RUNTIME_PROP_SLOTS,
  Slots,
  TOOLPAD_COMPONENT,
  TOOLPAD_COMPONENT_MODE_PROPERTY,
  TOOLPAD_FUNCTION,
  createComponent,
  createToolpadComponentThatThrows,
  getArgTypeDefaultValue,
  isToolpadComponent,
  useComponent,
  useComponents,
  useNode,
  useUrlQueryState
});
//# sourceMappingURL=index.cjs.map