"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/jsServerRuntime.tsx
var jsServerRuntime_exports = {};
__export(jsServerRuntime_exports, {
  createServerJsRuntime: () => createServerJsRuntime,
  useServerJsRuntime: () => useServerJsRuntime
});
module.exports = __toCommonJS(jsServerRuntime_exports);
var vm = __toESM(require("vm"), 1);
var React = __toESM(require("react"), 1);
var import_errors = require("@mui/toolpad-utils/errors");
function evalExpressionInContext(expression, globalScope = {}) {
  try {
    const value = vm.runInNewContext(expression, globalScope);
    return { value };
  } catch (rawError) {
    return { error: (0, import_errors.errorFrom)(rawError) };
  }
}
function createServerJsRuntime(env) {
  return {
    getEnv() {
      if (env) {
        return env;
      }
      throw new Error(`Env variables are not supported in this context`);
    },
    evaluateExpression: (code, globalScope) => evalExpressionInContext(code, globalScope)
  };
}
function useServerJsRuntime() {
  return React.useMemo(() => {
    const processEnv = {};
    return createServerJsRuntime(processEnv);
  }, []);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createServerJsRuntime,
  useServerJsRuntime
});
//# sourceMappingURL=jsServerRuntime.cjs.map