"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/server.ts
var server_exports = {};
__export(server_exports, {
  createFunction: () => createFunction,
  createQuery: () => createQuery,
  createServerContext: () => createServerContext,
  getContext: () => getContext,
  withContext: () => withContext
});
module.exports = __toCommonJS(server_exports);
var import_node_async_hooks = require("async_hooks");
var cookie = __toESM(require("cookie"), 1);

// src/constants.ts
var TOOLPAD_COMPONENT = Symbol.for("ToolpadComponent");
var TOOLPAD_FUNCTION = Symbol.for("ToolpadFunction");

// src/server.ts
function createFunction(resolver, config) {
  if (config?.parameters) {
    for (const [name, argType] of Object.entries(config.parameters)) {
      const maybeLegacyParamtype = argType;
      if (maybeLegacyParamtype.typeDef) {
        console.warn(`Detected deprecated parameter definition for "${name}".`);
        Object.assign(maybeLegacyParamtype, maybeLegacyParamtype.typeDef);
        if (!("default" in maybeLegacyParamtype)) {
          maybeLegacyParamtype.default = maybeLegacyParamtype.defaultValue;
        }
        delete maybeLegacyParamtype.defaultValue;
        delete maybeLegacyParamtype.typeDef;
      }
    }
  }
  return Object.assign(resolver, {
    [TOOLPAD_FUNCTION]: config || { parameters: {} }
  });
}
var createQuery = createFunction;
var asyncLocalStorage = new import_node_async_hooks.AsyncLocalStorage();
function getContext() {
  const ctx = asyncLocalStorage.getStore();
  if (!ctx) {
    throw new Error("getContext() must be called from within a Toolpad function.");
  }
  return ctx;
}
function createServerContext(req) {
  const cookies = cookie.parse(req.headers.cookie || "");
  return {
    cookies
  };
}
function withContext(ctx, doWork) {
  return asyncLocalStorage.run(ctx, doWork);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createFunction,
  createQuery,
  createServerContext,
  getContext,
  withContext
});
//# sourceMappingURL=server.cjs.map