"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/useUrlQueryState.ts
var useUrlQueryState_exports = {};
__export(useUrlQueryState_exports, {
  default: () => useUrlQueryState
});
module.exports = __toCommonJS(useUrlQueryState_exports);
var React = __toESM(require("react"), 1);
function getLocationUrl() {
  return new URL((window.top ?? window).location.href);
}
function useUrlQueryState(param, defaultValue = "") {
  const [value, setValue] = React.useState(defaultValue);
  const isInitialized = React.useRef(false);
  React.useEffect(() => {
    const url = getLocationUrl();
    const currentUrlValue = url.searchParams.get(param);
    if (isInitialized.current) {
      if (currentUrlValue !== value) {
        if (currentUrlValue === defaultValue) {
          url.searchParams.delete(param);
        } else {
          url.searchParams.set(param, value);
        }
        window.history.pushState(null, "", String(url));
      }
    } else {
      if (typeof currentUrlValue === "string") {
        setValue(currentUrlValue);
      }
      isInitialized.current = true;
    }
  }, [param, value, defaultValue]);
  React.useEffect(() => {
    const handlePopState = () => {
      const url = getLocationUrl();
      const urlQueryValue = url.searchParams.get(param);
      setValue(urlQueryValue ?? defaultValue);
    };
    window.addEventListener("popstate", handlePopState);
    return () => {
      window.removeEventListener("popstate", handlePopState);
    };
  }, [param, defaultValue]);
  return [value, setValue];
}
//# sourceMappingURL=useUrlQueryState.cjs.map