declare const brand: unique symbol;
export interface Brand<B> {
    readonly [brand]: B;
}
export type Branded<A, B> = A & Brand<B>;
export type Expand<T> = T extends infer O ? {
    [K in keyof O]: O[K];
} : never;
export type ExpandNested<T> = T extends infer O ? {
    [K in keyof O]: Expand<O[K]>;
} : never;
export {};
